Package: MLE
Type: Package
Title: Maximum Likelihood Estimation of Various Univariate and
        Multivariate Distributions
Version: 1.7
Date: 2026-03-27
Authors@R: c( person("Michail", "Tsagris", role = c("aut", "cre"), email = "mtsagris@uoc.gr"), 
              person("Sofia", "Piperaki", role = c("aut"), email = "sofiapip23@gmail.com"),
              person( "Muhammad", "Imran", role = "ctb", email = "imranshakoor84@yahoo.com" ),
              person( "Rafail", "Vargiakakis", role = "aut", email = "rafailvargiakakis@gmail.com" ),
              person( "Nikolaos", "Kontemeniotis", role = "aut", email = "kontemeniotisn@gmail.com" ) )
Author: Michail Tsagris [aut, cre],
  Sofia Piperaki [aut],
  Muhammad Imran [ctb],
  Rafail Vargiakakis [aut],
  Nikolaos Kontemeniotis [aut]
Maintainer: Michail Tsagris <mtsagris@uoc.gr>
Depends: R (>= 4.0)
Imports: BGFD, bivpois, CCd, COMPoissonReg, Compositional, Directional,
        foldedt, geppe, gp, MN, Rfast, Rfast2
Suggests: mvcauchy, rangen
Description: Several functions for maximum likelihood estimation of various univariate and multivariate distributions. The list includes more than 100 functions for univariate continuous and discrete distributions, distributions that lie on the real line, the positive line, interval restricted, circular distributions. Further, multivariate continuous and discrete distributions, distributions for compositional and directional data, etc. Some references include Johnson N. L., Kotz S. and Balakrishnan N. (1994). "Continuous Univariate Distributions, Volume 1" <ISBN:978-0-471-58495-7>, Johnson, Norman L. Kemp, Adrianne W. Kotz, Samuel (2005). "Univariate Discrete Distributions". <ISBN:978-0-471-71580-1> and Mardia, K. V. and Jupp, P. E. (2000). "Directional Statistics". <ISBN:978-0-471-95333-3>. 
License: GPL (>= 2)
NeedsCompilation: no
Packaged: 2026-03-27 09:27:13 UTC; mtsag
Repository: CRAN
Date/Publication: 2026-03-27 16:20:02 UTC
Built: R 4.6.0; ; 2026-04-26 19:48:48 UTC; unix

#useDynLib(fsn, .registration = TRUE)

importFrom("BGFD", mBellB, mBellBX, mBellE, mBellEW, mBellEE, mBellF, mBellL,
           mBellW, mCBellB, mCBellBX, mCBellE, mCBellEW, mCBellEE, mCBellF,
           mCBellL, mCBellW)
importFrom("bivpois", bp.mle, bp.mle2)
importFrom("CCd", cc.mle, cc.mle0)
importFrom("COMPoissonReg", glm.cmp)
importFrom("Compositional", zad.est, alpha.mle, a.est)

importFrom("Directional", spcauchy.mle, spcauchy.mle2, sipc.mle, pkbd.mle,
           kent.mle, esag.mle, sespc.mle, wood.mle, circexp.mle, circbeta.mle,
           cardio.mle, ggvm.mle, cipc.mle, gcpc.mle, mmvm.mle, matrixfisher.mle)

importFrom("geppe", epois.mle, gep.mle, pe.mle)
importFrom("gp", gp.mle)
importFrom("MN", mn.mle)
importFrom("foldedt", halft.mle, halft1.mle, foldedt.mle)

importFrom("Rfast", tobit.mle, vm.mle, spml.mle, wrapcauchy.mle, colvm.mle,
           colpoisson.mle, colgeom.mle, colgammamle, colweibull.mle,
           colpareto.mle, colexpmle, colexp2.mle, colmaxboltz.mle,
           collindley.mle, colrayleigh.mle, colnormlog.mle, colinvgauss.mle,
           colnormal.mle, collaplace.mle, diri.nr2, poisson.mle, zip.mle,
           ztp.mle, negbin.mle, binom.mle, borel.mle, geom.mle, logseries.mle,
           betageom.mle, betabinom.mle, vmf.mle, multivmf.mle, acg.mle, iag.mle,
           mvnorm.mle, mvlnorm.mle, mvt.mle, invdir.mle, multinom.mle,
           dirimultinom.mle, ordinal.mle, gammamle, chisq.mle, weibull.mle,
           lomax.mle, foldnorm.mle, betaprime.mle, lognorm.mle, logcauchy.mle,
           loglogistic.mle, normlog.mle, halfnorm.mle, invgauss.mle, pareto.mle,
           expmle, exp2.mle, maxboltz.mle, rayleigh.mle, lindley.mle, beta.mle,
           ibeta.mle, logitnorm.mle, hsecant01.mle, normal.mle, gumbel.mle,
           cauchy.mle, logistic.mle, ct.mle, tmle, wigner.mle, laplace.mle)

importFrom("Rfast2", censweibull.mle, censpois.mle, colcensweibull.mle,
           colcenspois.mle, colspml.mle, colborel.mle, colordinal.mle,
           collognorm.mle, colhalfnorm.mle, colbeta.mle, collogitnorm.mle,
           colcauchy.mle, colpowerlaw.mle, colunitweibull.mle, colsp.mle,
           purka.mle, halfcauchy.mle, powerlaw.mle, gammapois.mle,
           multivm.mle, multispml.mle, zigamma.mle, ziweibull.mle, cauchy0.mle,
           gnormal0.mle, trunccauchy.mle, truncexpmle, kumar.mle, simplex.mle,
           zil.mle, unitweibull.mle, cbern.mle, sp.mle)

importFrom("stats", optim, optimise)

exportPattern("^[[:alpha:]]+")
exportPattern("^[^\\.]")

# mle

mle is a small, flexible, terminal-based text editor written in C.

Runs on Linux, Windows (cygwin or WSL), FreeBSD, and macOS.

[![Build Status](https://travis-ci.org/adsr/mle.svg?branch=master)](https://travis-ci.org/adsr/mle)

[![Packaging status](https://repology.org/badge/vertical-allrepos/mle.svg)](https://repology.org/project/mle/versions)

### Demos

[![asciicast](https://i.imgur.com/PZocaOT.png)](https://asciinema.org/a/162536)

* [Emacs-style jump](https://i.imgur.com/atS11HX.gif)
* [Large file benchmark](http://i.imgur.com/VGGMmGg.gif)
* [Older demos](http://imgur.com/a/ZBmmQ)

### Aims

* Keep codebase small and hackable
* Minimize build-time and run-time dependencies
* Make extensible and configurable
* Favor simplicity over portability
* Use shell commands to enhance functionality (e.g., grep, tree)

### Features

* Small codebase (~10k sloc)
* Full UTF-8 support
* Syntax highlighting
* Stackable key maps (modes)
* Extensible via [Lua](https://www.lua.org)
* Scriptable rc file
* Key macros
* Multiple splittable windows
* Regex search and replace
* Large file support
* Incremental search
* Linear undo and redo
* Multiple cursors
* Auto indent
* Headless mode
* Navigation via [ctags](https://github.com/universal-ctags/ctags)
* Movement via [less](https://www.gnu.org/software/less/)
* Fuzzy file search via [fzf](https://github.com/junegunn/fzf)
* File browsing via [tree](http://mama.indstate.edu/users/ice/tree/)
* File grep via [grep](https://www.gnu.org/software/grep/)
* String manip via [perl](https://www.perl.org/)

### Building

    $ sudo apt install git build-essential libtool automake # or equivalent
    $
    $ git clone --recursive https://github.com/adsr/mle.git
    $ cd mle
    $ make mle_vendor=1

To build a completely static binary, try `make mle_vendor=1 mle_static=1`.

You can also run plain `make` to link against system libraries instead of
`vendor/`. Note this requires the following packages to be installed:

    uthash-dev
    liblua5.4-dev
    libpcre3-dev

To install to `/usr/local/bin`:

    $ make install

To install to a custom directory, supply `prefix`, e.g.:

    $ make install prefix=/usr # /usr/bin/mle

### Installing from a repo

mle may be available to install via your system's package manager.

    # snap install mle  # all major Linux distros
    # apt install mle   # Ubuntu and Debian-based distros
    # pkg install mle   # FreeBSD
    # yay -S mle        # Arch (via AUR)
    # nix-env -i mle    # NixOS (via nixpkgs)
    # apk add mle       # Alpine
    # xbps-install mle  # Void

### Basic usage

    $ mle               # Open blank buffer
    $ mle one.c         # Edit one.c
    $ mle one.c:100     # Edit one.c at line 100
    $ mle one.c two.c   # Edit one.c and two.c
    $ mle -h            # Show command line help

The default key bindings are intuitive. Input text as normal, use directional
keys to move around, use `Ctrl-S` to save, `Ctrl-O` to open, `Ctrl-X` to exit.

Press `F2` for full help.

### Advanced usage: mlerc

mle is customized via command line options. Run `mle -h` to view all cli
options.

To set default options, make an rc file named `~/.mlerc` (or `/etc/mlerc`). The
contents of the rc file are any number of cli options separated by newlines.
Lines that begin with a semi-colon are interpretted as comments.

If `~/.mlerc` is executable, mle executes it and interprets the resulting stdout
as described above. For example, consider the following snippet from an
executable `~/.mlerc` bash(1) script:

    # Define 'test' kmap
    echo '-Ktest,,1'

    # M-q: replace grep with git grep if `.git` exists
    if [ -d ".git" ]; then
      echo '-kcmd_grep,M-q,git grep --color=never -P -i -I -n %s 2>/dev/null'
    fi

    # Set default kmap
    echo '-n test'

This overrides the built-in grep command with `git grep` if `.git` exists in
the current working directory.

### Shell command integration

The following programs will enable or enhance certain features of mle if they
exist in `PATH`.

* [bash](https://www.gnu.org/software/bash/) (tab completion)
* [fzf](https://github.com/junegunn/fzf) (fuzzy file search)
* [grep](https://www.gnu.org/software/grep/) (file grep)
* [less](https://www.gnu.org/software/less/) (less integration)
* [perl](https://www.perl.org/) (perl 1-liners)
* [readtags](https://github.com/universal-ctags/ctags) (ctags integration)
* [tree](http://mama.indstate.edu/users/ice/tree/) (file browsing)

Arbitrary shell commands can also be run via `cmd_shell` (M-e by default). If
any text is selected, it is sent to stdin of the command. Any resulting stdout
is inserted into the text buffer.

### Advanced usage: Headless mode

mle provides support for non-interactive editing which may be useful for using
the editor as a regular command line tool. In headless mode, mle reads stdin
into a buffer, applies a startup macro if specified, and then writes the buffer
contents to stdout. For example:

    $ echo -n hello | mle -M 'test C-e space w o r l d enter' -p test
    hello world

If stdin is a pipe, mle goes into headless mode automatically. Headless mode can
be explicitly enabled or disabled with the `-H` option.

If stdin is a pipe and headless mode is disabled via `-H0`, mle reads stdin into
a new buffer and then runs as normal in interactive mode.

### Advanced usage: Scripting

mle is extensible via the [Lua](https://www.lua.org) programming language.
Scripts are loaded via the `-x` cli option. Commands registered by scripts can
be mapped to keys as normal via `-k`. See `uscript.lua` for a simple example.

There is also a `wren` branch with [Wren](http://wren.io) scripting support.
That work is on pause.

### Known bugs

* Multi-line style rules don't work properly when overlapped/staggered.

### Forks

* [eon](https://github.com/tomas/eon) - mouse support and Notepad-like
  selections
* [turbo-mle](https://github.com/magiblot/turbo-mle) - Turbo Vision port

### Acknowledgments

mle makes extensive use of the following libraries.

* [uthash](https://troydhanson.github.io/uthash) for hash maps and linked lists
* [termbox2](https://github.com/termbox/termbox2) for TUI
* [PCRE](http://www.pcre.org/) for syntax highlighting and search

cens.mle <- function(x, distr = "tobit", di, tol = 1e-07) {
  if ( distr == "tobit" ) {
    res <- Rfast::tobit.mle(x, tol = tol)
  } else if ( distr == "censweibull" ) {
    res <- Rfast2::censweibull.mle(x, di, tol = tol)
  } else if ( distr == "censpois" ) {
    res <- Rfast2::censpois.mle(x, tol = tol)
  }
  res
}

positive.mle <- function(x, distr = "gamma", tol = 1e-07, maxiters = 100) {
  if ( distr == "gamma" ) {
    res <- Rfast::gammamle(x, tol = tol)
  } else if ( distr == "chisq" ) {
    res <- Rfast::chisq.mle(x, tol = tol)
  } else if ( distr == "weibull" ) {
    res <- Rfast::weibull.mle(x, tol = tol, maxiters = maxiters)
  } else if ( distr == "lomax" ) {
    res <- Rfast::lomax.mle(x, tol = tol)
  } else if ( distr == "foldnorm" ) {
    res <- Rfast::foldnorm.mle(x, tol = tol)
  } else if ( distr == "betaprime" ) {
    res <- Rfast::betaprime.mle(x, tol = tol)
  } else if ( distr == "lognorm" ) {
    res <- Rfast::lognorm.mle(x)
  } else if ( distr == "logcauchy" ) {
    res <- Rfast::logcauchy.mle(x, tol = tol)
  } else if ( distr == "loglogistic" ) {
    res <- Rfast::loglogistic.mle(x, tol = tol)
  } else if ( distr == "normlog" ) {
    res <- Rfast::normlog.mle(x)
  } else if ( distr == "halfnorm" ) {
    res <- Rfast::halfnorm.mle(x)
  } else if ( distr == "invgauss" ) {
    res <- Rfast::invgauss.mle(x)
  } else if ( distr == "pareto" ) {
    res <- Rfast::pareto.mle(x)
  } else if ( distr == "exp" ) {
    res <- Rfast::expmle(x)
  } else if ( distr == "exp2" ) {
    res <- Rfast::exp2.mle(x)
  } else if ( distr == "maxboltz" ) {
    res <- Rfast::maxboltz.mle(x)
  } else if ( distr == "rayleigh" ) {
    res <- Rfast::rayleigh.mle(x)
  } else if ( distr == "lindley" ) {
    res <- Rfast::lindley.mle(x)
  } else if ( distr == "zigamma") {
    res <- Rfast2::zigamma.mle(x, tol = tol)
  } else if ( distr == "ziweibull" ) {
    res <- Rfast2::ziweibull.mle(x, tol = tol)
  } else if (distr == "epois" ) {
    res <- geppe::epois.mle(x)
  } else if (distr == "gep" ) {
    res <- geppe::gep.mle(x)
  } else if (distr == "pe" ) {
    res <- geppe::pe.mle(x)
  } else if ( distr == "halfcauchy" ) {
    res <- Rfast2::halfcauchy.mle(x, tol = tol )
  } else if ( distr == "powerlaw" ) {
    res <- Rfast2::powerlaw.mle(x)
  } else if (distr == "halft" ) {
    res <- foldedt::halft.mle(x)
  } else if (distr == "halft1" ) {
    res <- foldedt::halft1.mle(x)
  } else if (distr == "foldedt" ) {
    res <- foldedt::foldedt.mle(x)
  } else if (distr == "wp" ) {
    res <- .wp.mle(x)
  } else if (distr == "be" ) {
    res <- .be.mle(x)
  } else if (distr == "frechet2" ) {
    res <- .fng.mle(x)
  }
  res
}


.wp.mle <- function(x) {

  wp <- function(vec, x, slx, n) {
    alpha <- exp( vec[1] )
    b <- exp( vec[2] )
    lambda <- exp( vec[3] )
    logca <- log(alpha * b * lambda) - lambda - log(1 - exp(- lambda) )
     -n * logca + b * sum( x^alpha ) - (alpha - 1) * slx - lambda * sum( exp(- b * ( x^alpha ) ) )
  }

  n <- length(x)  ;  slx <- sum( log( x ) )
  f <- optim( par = c(1, 1, 1), fn = wp, x = x, slx = slx, n = n, control = list(maxit = 5000) )
  f <- optim( par = f$par, fn = wp, x = x, n = n, slx = slx, control = list(maxit = 5000) )
  param <- exp( f$par )
  names(param) <- c("alpha", "beta", "lambda")
  list(param = param, loglik = -f$value)
}


.be.mle <- function(x) {

  be <- function(vec, x, sx, n) {
    alpha <- exp( vec[1] )
    b <- exp( vec[2] )
    lambda <- exp( vec[3] )
    -n * log( lambda ) + n * lbeta( b, alpha ) + alpha * lambda * sx - (b - 1) * sum( log(1 - exp(- lambda * x ) ) )
  }

  n <- length(x)  ;  sx <- sum(x)
  f <- optim( par = c(1, 1, 1), fn = be, x = x, sx = sx, n = n, control = list(maxit = 5000) )
  f <- optim( par = f$par, fn = be, x = x, n = n, sx = sx, control = list(maxit = 5000) )
  param <- exp( f$par )
  names(param) <- c("alpha", "beta", "lambda")
  list(param = param, loglik = -f$value)
}


.fng.mle <- function(x) {

  ##- ( n * log( gamma ) - n * log( b ) - ( gamma + 1 ) * sum( log( x / b ) )  -
  ##( ( 1 / b ) ^ ( - gamma ) ) * sum( x ^ ( - gamma ) ) )
  fng <- function(vec, x, slx, n) {
    b <- exp( vec[1] )
    gamma <- exp( vec[2] )
    - n * log( gamma ) + n * log( b ) + ( gamma + 1 ) * ( slx - n * vec[1] ) +
      ( ( 1 / b ) ^ ( - gamma ) ) * sum( x ^ ( - gamma ) )
  }

  mod <- optim( par = c(1, 1), fng, x = x, slx = sum( log(x) ), n = length(x) )
  param <- exp(mod$par)
  names(param) <- c("beta", "gamma")
  list(param = param, loglik = -mod$value)
}

bell.mle <- function(x, a, b, k, lambda, distr = "BB12", method = "B") {
  if ( distr == "BB12" ) {
    res <- BGFD::mBellB(x, a = a, b = b, k = k, lambda = lambda, method = method)
    param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "kappa", "lambda")
  } else if ( distr == "BBX" ) {
    res <- BGFD::mBellBX(x, a = a, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha",  "lambda")
  } else if ( distr == "BE" ) {
    res <- BGFD::mBellE(x, alpha = a,lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha",  "lambda")
  } else if ( distr == "BEW" ) {
    res <- BGFD::mBellEW(x, alpha = a, beta = b, theta = k, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "theta", "lambda")
  } else if ( distr == "BEE" ) {
    res <- BGFD::mBellEE(x, alpha = a, beta = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  } else if ( distr == "BF" ) {
    res <- BGFD::mBellF(x, a = a, b = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  } else if ( distr == "BL" ) {
    res <- BGFD::mBellL(x, b=a, q=b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("beta", "q", "lambda")
  } else if ( distr == "BW" ) {
    res <- BGFD::mBellW(x, alpha = a, beta = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  } else if ( distr == "CBB12" ) {
    res <- BGFD::mCBellB(x, a = a, b = b, k=k, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "kappa", "lambda")
  } else if ( distr == "CBBX" ) {
    res <- BGFD::mCBellBX(x, a = a, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha",  "lambda")
  } else if ( distr == "CBE" ) {
    res <- BGFD::mCBellE(x, alpha = a, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha",  "lambda")
  } else if ( distr == "CBEW" ) {
    res <- BGFD::mCBellEW(x, alpha = a, beta = b, theta = k, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "theta", "lambda")
   } else if ( distr == "CBEE" ) {
    res <- BGFD::mCBellEE(x, alpha = a, beta = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  } else if ( distr == "CBF" ) {
    res <- BGFD::mCBellF(x, a = a, b = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  } else if ( distr == "CBL" ) {
    res <- BGFD::mCBellL(x, b=a, q=b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("beta", "q", "lambda")
  } else if ( distr == "CBW" ) {
    res <- BGFD::mCBellW(x, alpha = a, beta = b, lambda = lambda, method = method)
	  param <- res$Estimates[, 1]
    names(param) <- c("alpha", "beta", "lambda")
  }
  list( param = param, loglik = -0.5 * res[[ 2 ]][5] )
}

mv.mle <- function(x, distr = "mvnorm", v = 1, tol = 1e-7) {
  if ( distr == "mvnorm" ) {
     res <- Rfast::mvnorm.mle(x)
  } else if ( distr == "mvlnorm" ) {
     res <- Rfast::mvlnorm.mle(x)
  } else if ( distr == "mvt" ) {
    res <- Rfast::mvt.mle(x, v = v, tol = tol)
  } else if ( distr == "invdir" ) {
    res <- Rfast::invdir.mle(x, tol = tol)
  }
  res
}

hspher.mle <- function(x, distr = "vmf", ina, full = FALSE, ell = FALSE, tol = 1e-07) {
   if ( distr == "vmf" ) {
     res <- Rfast::vmf.mle(x, tol = tol)
   } else if ( distr == "multivmf" ) {
     res <- Rfast::multivmf.mle(x , ina, tol = tol, ell = ell)
   } else if ( distr == "acg" ) {
     res <- Rfast::acg.mle(x, tol = tol)
   } else if ( distr == "iag" ) {
     res <- Rfast::iag.mle(x, tol = tol)
   } else if ( distr == "spcauchy" ) {
     res <- Directional::spcauchy.mle(x, tol = tol)
   } else if ( distr == "spcauchy2" ) {
     res <- Directional::spcauchy.mle2(x, tol = tol)
   } else if ( distr == "sipc" ) {
     res <- Directional::sipc.mle(x, tol = tol)
   } else if ( distr == "pkbd" ) {
     res <- Directional::pkbd.mle(x, tol = tol)
   } else if ( distr == "pkbd2" ) {
     res <- Directional::pkbd.mle2(x, tol = tol)
   } else if ( distr == "purka" ) {
      res <- Rfast2::purka.mle(x)
   } else if ( distr == "kent" ) {
     res <- Directional::kent.mle(x)
   } else if ( distr == "esag" ) {
     res <- Directional::esag.mle(x, full = full, tol = tol)
    } else if ( distr == "sespc" ) {
     res <- Directional::sespc.mle(x, full = full, tol = tol)
    } else if ( distr == "ESAGd" ) {
      res <- Directional::ESAGd.mle(x, full = full)
    } else if ( distr == "svmf" ) {
      res <- svmf::svmf.mle(x, full = full)
   } else if ( distr == "wood" ) {
     res <- Directional::wood.mle(x)
   }
   res
}

coldisc.mle <- function(x, distr = "poisson", N = NULL, type = 1, tol = 1e-7) {
  if ( distr == "poisson" ) {
    res <- Rfast::colpoisson.mle(x)
  } else if ( distr == "geom" ) {
    res <- Rfast::colgeom.mle(x , type = type)
  } else if ( distr == "borel" ) {
    res <- Rfast2::colborel.mle(x)
  } else if ( distr == 'zip' ) {
    res <- .colzip.mle(x, tol = tol)
  } else if ( distr == 'ztp' ) {
    res <- .colztp.mle(x, tol = tol)
  } else if ( distr == 'negbin' ) {
    res <- .colnegbin.mle(x, type = type, tol = tol)
  } else if ( distr == 'binom' ) {
    res <- .colbinom.mle(x, N = N, tol = tol)
  } else if ( distr == 'logseries' ) {
    res <- .collogseries.mle(x, tol = tol)
  } else if ( distr == 'betageom' ) {
    res <- .colbetageom.mle(x, tol = tol)
  } else if ( distr == 'betabinom' ) {
    res <- .colbetabinom.mle(x, N = N, tol = tol)
  } else if ( distr == 'gammapois' ) {
    res <- .colgammapois.mle(x, tol = tol)
  } else if ( distr == 'skellam' ) {
    res <- .colskellam.mle(x)
  } else if ( distr == 'gp' ) {
    res <- .colgp.mle(x)
  } else if ( distr == 'cc' ) {
    res <- .colcc.mle(x)
  } else if ( distr == 'cc0' ) {
    res <- .colcc0.mle(x)
  } else if ( distr == 'com-pois' ) {
    res <- .colcom_pois.mle(x)
  } else if ( distr == "zicom-pois" ) {
    res <- .colzicom_pois.mle(x)
  } else if ( distr == "tppxg" ) {
    res <- .coltppxg.mle(x)
  } else if ( distr == "tpxg" ) {
    res <- .coltpxg.mle(x)
  }
  res
}


#----colzip.mle-----------
.colzip.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::zip.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'lambda', 'pi')
  res
}

#---colztp.mle-----
.colztp.mle <- function(x, tol) {
  n <- dim(x)[2]
  res<-matrix(nrow = n, ncol = 3)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::ztp.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'lambda')
  res
}

#----colnegbin.mle------
.colnegbin.mle <- function(x, type, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 5)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::negbin.mle(x[, i], type, tol) )
  colnames(res) <- c('iters', 'loglik', 'success probability', 'number of failures', 'mean')
  res
}

#-----colbinom.mle-----
.colbinom.mle <- function(x, N = NULL, tol) {
  n <- dim(x)[2]
  if ( !is.null(N) ) {
    res <- matrix(nrow = n, ncol = 2)
    for ( i in 1:n )  res[i, ] <- unlist( Rfast::binom.mle(x[, i], N = N[i], tol = tol) )
    colnames(res) <- c("loglik", "probability")
  } else {
    res <- matrix(nrow = n, ncol = 4)
    for ( i in 1:n )  res[i, ] <- unlist( Rfast::binom.mle(x[, i], N = NULL, tol = tol) )
    colnames(res) <- c("iters", "loglik", "Number of trials", "probability")
  }
  res
}

#----collogseries.mle-----
.collogseries.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::logseries.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'prob', 'loglik')
  res
}

#-----colbetageom.mle-------
.colbetageom.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::betageom.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'alpha', 'beta')
  res
}

#----colbetabinom.mle-----
.colbetabinom.mle <- function(x, N, tol = tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::betabinom.mle(x[, i], N = N[i], tol = tol) )
  colnames(res) <- c('iters', 'alpha', 'beta', 'loglik')
  res
}

#----colgammapois.mle-----
.colgammapois.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast2::gammapois.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'shape', 'scale')
  res
}

#----colskellam.mle---
.colskellam.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( .skellam.mle(x[, i]) )
  colnames(res) <- c('mu1', 'mu2', 'loglik')
  res
}

#---colgp.mle------
.colgp.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n )  res[i, ] <- unlist( gp::gp.mle(x[, i]) )
  colnames(res) <- c('theta', 'lambda', 'loglik')
  res
}

#---collcc.mle-----------
.colcc.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n )  res[i, ] <- unlist( CCd::cc.mle(x[, i]) )
  colnames(res) <- c('mu', 'lambda', 'loglik')
  res
}

#---collcc0.mle-----------
.colcc0.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 2)
  for ( i in 1:n )  res[i,] <- unlist( CCd::cc.mle0(x[, i]) )
  colnames(res) <- c('lambda', 'loglik')
  res
}

#---colcom_pois.mle----
.colcom_pois.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n ) {
    a <- COMPoissonReg::glm.cmp(X ~ 1)
    res[i, ] <- c( exp( unlist(a[[ 10 ]]$par) ), a[[ 9 ]] )
  }
  colnames(res) <- c('lambda', 'nu', 'loglik')
  res
}

#---colzicom_pois.mle----
.colzicom_pois.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n ) {
    a <- COMPoissonReg::glm.cmp(x ~ 1, formula.p = ~1)
    res[i, ] <- c( exp( unlist(a[[ 12 ]]$par) ), a[[ 11 ]] )
  }
  colnames(res) <- c('lambda', 'nu', 'p', 'loglikelihood')
  res
}

#---coltppxg.mle----
.coltppxg.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n )  res[i, ] <- TPXG::tppxg.mle(x)
  colnames(res) <- c('alpha', 'theta', 'loglikelihood')
  res
}

#---coltpxg.mle----
.coltpxg.mle <- function(x) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for ( i in 1:n )  res[i, ] <- TPXG::tpxg.mle(x)
  colnames(res) <- c('alpha', 'theta', 'loglikelihood')
  res
}

colprop.mle <- function(x, distr = "beta", tol = 1e-07, maxiters = 100, parallel = FALSE ){
  if ( distr == "beta" ) {
    res <- Rfast2::colbeta.mle(x, tol = tol, maxiters = maxiters, parallel = parallel)
  } else if ( distr == "logitnorm" ) {
    res <- Rfast2::collogitnorm.mle(x)
  } else if ( distr == "unitweibull" ) {
    res <- Rfast2::colunitweibull.mle(x, tol = tol, maxiters = maxiters, parallel = parallel)
  } else if ( distr == "sp" ) {
    res <- Rfast2::colsp.mle(x)
  } else if ( distr == "ibeta" ) {
    res <- .colibeta.mle(x, tol = tol)
  } else if ( distr == "hsecant01" ) {
    res <- .colhsecant01.mle(x, tol = tol)
  } else if ( distr == "kumar" ) {
    res <- .colkumar.mle(x, tol = tol, maxiters = maxiters)
  } else if ( distr == "simplex" ) {
    res <- .colsimplex.mle(x, tol = tol)
  } else if ( distr == "zil" ) {
    res <- .colzil.mle(x)
  } else if ( distr == "cbern" ) {
    res <- .colcbern.mle(x, tol = tol)
  }

  res
}


.colibeta.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] ) {
    a <- Rfast::ibeta.mle(x[,i], tol = tol)
    res[i, 1] <- c( a[2][[ 1 ]]$param[[ 1 ]], a[2][[ 1 ]]$param[[ 2 ]], a[2][[ 1 ]]$loglik )
  }
  colnames(res) <- c("alpha", "beta", "loglik")
  res
}

.colhsecant01.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 2)
  for (i in 1:ncol(x)){
    a <- Rfast::hsecant01.mle(x[,i], tol = tol)
    res[i, ] <- c( a$theta, a$loglik )
  }
  colnames(res) <- c("theta", "loglik")
  res
}

.colkumar.mle <- function(x, tol = tol, maxiters = maxiters) {
  res <- matrix(NA, dim(x)[2], 3 )
  for ( i in 1:dim(x)[2] ) {
    a <- Rfast2::kumar.mle(x[,i], tol = tol, maxiters = maxiters)
    res[i,1] <- c( a$param[[ 1 ]], a$param[[ 2 ]], a$loglik )
  }
  colnames(res) <- c("shape", "scale", "loglik")
  res
}

.colsimplex.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3 )
  for ( i in 1:dim(x)[2] ) {
    a <- Rfast2::simplex.mle(x[,i], tol = tol)
    res[i, ] <- c( a$param[[ 1 ]], a$param[[ 2 ]], a$loglik )
  }
  colnames(res) <- c("mean", "sigma", "loglik")
  res
}

.colzil.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] ) {
    a <- Rfast2::zil.mle(x[, i])
    res[i, ] <- c(a$param, a$loglik)
  }
  colnames(res) <- c("prop1", "mean", "unbiased variance", "loglik")
  res
}

.colcbern.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 2)
  for ( i in 1:dim(x)[2] ) {
    a <- Rfast2::cbern.mle(x[, i], tol = tol)
    res[i, ] <- c( a$lam, a$loglik )
  }
  colnames(res) <- c("lam", "loglik")
  res
}

.colgarcsine.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 2)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( .garcsine.mle(x[, i]) )
  colnames(res) <- c("alpha", "loglik")
  res
}

colpositive.mle <- function(x, distr = "gamma", tol = 1e-07, maxiters = 100, parallel = FALSE){
  if ( distr == "gamma" ) {
    res <- Rfast::colgammamle(x, tol = 1e-07)
  } else if ( distr == "weibull" ) {
    res <- Rfast::colweibull.mle(x, tol = tol, maxiters = maxiters, parallel = parallel) ###
  } else if ( distr == "pareto" ) {
    res <- Rfast::colpareto.mle(x)
  } else if ( distr == "exp" ) {
    res <- Rfast::colexpmle(x)
  } else if ( distr == "exp2" ) {
    res <- Rfast::colexp2.mle(x)
  } else if ( distr == "maxboltz" ) {
    res <- Rfast::colmaxboltz.mle(x)
  } else if ( distr == "lindley" ) {
    res <- Rfast::collindley.mle(x)
  } else if ( distr == "rayleigh" ) {
    res <- Rfast::colrayleigh.mle(x)
  } else if ( distr == "lognorm" ) {
    res <- Rfast2::collognorm.mle(x)
  } else if ( distr == "halfnorm" ) {
    res <- Rfast2::colhalfnorm.mle(x)
  } else if ( distr == "normlog" ) {
    res <- Rfast::colnormlog.mle(x)
  } else if ( distr == "invgauss" ) {
    res <- Rfast::colinvgauss.mle(x)
  } else if ( distr == "powerlaw" ) {
    res <- Rfast2::colpowerlaw.mle(x)
  } else if ( distr == "chisq" ) {
    res <- .colchisq.mle(x)
  } else if ( distr == "foldnorm" ) {
    res <- .colfoldnorm.mle(x)
  } else if ( distr == "betaprime" ) {
    res <- .colbetaprime.mle(x)
  } else if ( distr == "logcauchy" ) {
    res <- .collogcauchy.mle(x)
  } else if ( distr == "loglogistic" ) {
    res <- .colloglogistic.mle(x)
  } else if ( distr == "zigamma" ) {
    res <- .colzigamma.mle(x)
  } else if ( distr == "ziweibull" ) {
    res <- .colziweibull.mle(x)
  } else if ( distr == "epois" ) {
    res <- .colepois.mle(x)
  } else if ( distr == "gep" ) {
    res <- .colgep.mle(x)
  } else if ( distr == "pe" ) {
    res <- .colpe.mle(x)
  } else if ( distr == "gep" ) {
    res <- .colgep.mle(x)
  } else if ( distr == "halfcauchy" ) {
    res <- .colhalfcauchy.mle
  } else if ( distr == "wp" ) {
    res <- .colwp.mle(x)
  } else if ( distr == "be" ) {
    res <- .colbe.mle(x)
  } else if ( distr == "frechet2" ) {
    res <- .colfng.mle(x)
  } else if (distr == "halft" ) {
    res <- .colhalft.mle(x)
  } else if (distr == "halft1" ) {
    res <- .colhalft1.mle(x)
  } else if (distr == "foldedt" ) {
    res <- .colfoldedt.mle(x)
  }
  res
}


.colchisq.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast::chisq.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters", "loglik", "nu")
  res
}

.colfoldnorm.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist(Rfast::foldnorm.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters", "loglik", "mean", "sigma squared")
  res
}

.colbetaprime.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast::betaprime.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters", "loglik", "alpha", "beta")
  res
}

.collogcauchy.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast::logcauchy.mle(x[,i], tol = tol) )
  colnames(res) <- c("loglik", "location", "scale")
  res
}

.colloglogistic.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast::loglogistic.mle(x[,i], tol = tol) )
  colnames(res) <- c("loglik", "location", "scale")
  res
}

.colzigamma.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i,] <- unlist(Rfast2::zigamma.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters", "loglik", "prop1", "shape", "scale")
  res
}

.colziweibull.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast2::ziweibull.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters","loglik", "prop1", "shape", "scale")
  res
}

.colepois.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( geppe::epois.mle(x[, i]) )
  colnames(res) <- c("beta", "lambda", "loglik")
  res
}

.colgep.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( geppe::gep.mle(x[, i]) )
  colnames(res) <- c("beta","alpha","lambda", "loglik")
  res
}

.colpe.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( geppe::pe.mle(x[, i]) )
  colnames(res) <- c("theta","lambda", "loglik")
  res
}

.colhalfcauchy.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast2::halfcauchy.mle(x[, i], tol = tol ) )
  colnames(res) <- c("iters","loglik", "scale")
  res
}

.colwp.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( .wp.mle(x[, i]) )
  colnames(res) <- c("alpha","beta", "lambda","loglik")
  res
}

.colbe.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for (i in 1:dim(x)[2] ) res[i, ] <- unlist( .be.mle(x[, i]) )
  colnames(res) <- c("alpha","beta", "lambda","loglik")
  res
}

.colfng.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for (i in 1:dim(x)[2] )  res[i, ] <- unlist( .fng.mle(x[, i]) )
  colnames(res) <- c("beta", "gamma","loglik")
  res
}

.colhalft1.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for (i in 1:dim(x)[2] )  res[i, ] <- unlist( foldedt::halft1.mle(x[, i]) )
  colnames(res) <- c("iters", "nu","loglik")
  res
}

.colhalft.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for (i in 1:dim(x)[2] )  res[i, ] <- unlist( foldedt::halft.mle(x[, i]) )
  colnames(res) <- c("nu", "scatter","loglik")
  res
}

.colfoldedt.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for (i in 1:dim(x)[2] )  res[i, ] <- unlist( foldedt::foldedt.mle(x[, i]) )
  colnames(res) <- c("location", "scatter","nu", "loglik")
  res
}

prop.mle <- function(x, distr = "beta", tol = 1e-07, maxiters = 50) {
  if ( distr == "beta" ) {
    res <- Rfast::beta.mle(x, tol = tol)
  } else if ( distr == "ibeta" ) {
    res <- Rfast::ibeta.mle(x, tol = tol)
  } else if ( distr == "logitnorm" ) {
    res <- Rfast::logitnorm.mle(x)
  } else if ( distr == "hsecant01" ) {
    res <- Rfast::hsecant01.mle(x, tol = tol)
  } else if ( distr == "kumar" ) {
    res <- Rfast2::kumar.mle(x, tol = tol, maxiters = maxiters)
  } else if ( distr == "simplex" ) {
    res <- Rfast2::simplex.mle(x, tol = tol)
  } else if ( distr == "zil" ) {
    res <- Rfast2::zil.mle(x)
  } else if ( distr == "unitweibull" ) {
    res <- Rfast2::unitweibull.mle(x, tol = tol, maxiters = maxiters)
  } else if ( distr == "cbern" ) {
    res <- Rfast2::cbern.mle(x, tol = tol)
  } else if ( distr == "sp" ) {
    res <- Rfast2::sp.mle(x)
  } else if ( distr == "garcsine" ) {
    res <- .garcsine.mle(x)
  }

  res
}

.garcsine.mle <- function(x) {
  n <- length(x)
  slx <- sum( log(x) )
  slx1 <- sum( log(1 - x) )
  fun <- function(a, n, slx, slx1)  n * log( sin(a * pi) ) - a * slx + (a - 1) * slx1
  mod <- optimise(fun, c(0, 1), n = n, slx = slx, slx1 = slx1, maximum = TRUE, tol = 1e-7)
  list(alpha = mod$maximum, loglik = mod$objective - n * log(pi))
}

mvdisc.mle <- function(x, distr = "multinom", tol = 1e-07) {
  if ( distr == "multinom" ) {
    res <- Rfast::multinom.mle(x)
  } else if ( distr == "dirimultinom" ) {
    res <- Rfast::dirimultinom.mle(x , tol = tol)
  } else if ( distr == "bp" ) {
    res <- bivpois::bp.mle(x1 = x, x2 = NULL)
  } else if ( distr == "bp2" ) {
    res <- bivpois::bp.mle2(x1 = x, x2 = NULL)
  }
  res
}

truncmle <- function(x, distr = "trunccauchy", a, b, tol = 1e-07) {
  if ( distr == "trunccauchy") {
    res <- Rfast2::trunccauchy.mle(x, a, b, tol = tol)
  } else if ( distr == "truncexpmle" ) {
    res <- Rfast2::truncexpmle(x, b, tol = tol)
  }
  res
}

comp.mle <- function(x, distr = "diri", type = 1, a = NULL, tol = 1e-07) {
  if ( distr == "diri" ) {
    res <- Rfast::diri.nr2(x, type = type, tol = tol)
  } else if ( distr == "zad" ) {
    res <- Compositional::zad.est(x)
  } else if ( distr == "afolded" ) {
    if ( !is.null(a) ) {
      res <- Compositional::alpha.mle(x, a)
    } else {
      res <- Compositional::a.est(x)
    }
  }
  res
}

disc.mle <- function(x, distr = "poisson", N = NULL, type = 1, tol = 1e-07) {
  if ( distr == "poisson" ) {
    res <- Rfast::poisson.mle(x)
  } else if ( distr == "zip" ) {
    res <- Rfast::zip.mle(x, tol = tol)
  } else if ( distr == "ztp" ) {
    res <- Rfast::ztp.mle(x, tol = tol)
  } else if ( distr == "negbin" ) {
    res <- Rfast::negbin.mle(x, type = type, tol = tol)
  } else if ( distr == "binom" ) {
    res <- Rfast::binom.mle(x, N = N, tol = tol)
  } else if ( distr == "borel" ) {
    res <- Rfast::borel.mle(x)
  } else if ( distr == "geom" ) {
    res <- Rfast::geom.mle(x, type = type)
  } else if ( distr == "logseries" ) {
    res <- Rfast::logseries.mle(x, tol = tol)
  } else if ( distr == "betageom" ) {
    res <- Rfast::betageom.mle(x, tol = tol)
  } else if ( distr == "betabinom" ) {
    res <- Rfast::betabinom.mle(x, N = N, tol = tol)
  } else if ( distr == "gammapois" ) {
    res <- Rfast2::gammapois.mle(x, tol = tol)
  } else if ( distr == "skellam" ) {
    res <- .skellam.mle(x)
  } else if ( distr == "gp" ) {
    res <- gp::gp.mle(x)
  } else if( distr == "cc" ) {
    res <- CCd::cc.mle(x)
  } else if( distr == "cc0" ) {
    res <- CCd::cc.mle0(x, tol = tol)
  } else if ( distr == "com-pois" ) {
    a <- COMPoissonReg::glm.cmp(x ~ 1)
	  param <- exp( a[[10]]$par )
	  names(param) <- c("lambda", "nu")
    loglik <- a[[ 9 ]]
	  res <- list(param = param, loglik = loglik)
  } else if ( distr == "zicom-pois" ) {
    a <- COMPoissonReg::glm.cmp(x ~ 1, formula.p = ~1)
	  param <- exp( a[[12]]$par )
	  names(param) <- c("lambda", "nu", "p")
    loglik <- a[[ 11 ]]
	  res <- list(param = param, loglik = loglik)
  } else if ( distr == "tppxg" ) {
    res <- TPXG::tppxg.mle(x)
  } else if ( distr == "tpxg" ) {
    res <- TPXG::tpxg.mle(x)
  }

  res
}



.skellam.mle <- function(x) {

  n <- length(x)
  sx <- sum(x)
  sx2 <- sx / 2
  mx <- sx / n
  theta <- stats::var(x)/2  - mx/2

  skel <- function(theta) {
    a <- 2 * sqrt(theta^2 + theta * mx)
    n * 2 * theta + sx - sx2 * log(1 + mx / theta) -
    sum( log( besselI(a, x, expon.scaled = TRUE) ) ) - n * a
  }

  mod <- optim(theta, skel, control = list(maxit = 5000) )
  param <- c( mod$par + mx, mod$par )
  names(param) <- c("mu 1", "mu 2")
  list(param = param, loglik = -mod$value)

}

colreal.mle <- function(x, distr = "normal", v = 5, tol = 1e-07, maxiters = 100, parallel = FALSE) {
  if ( distr == "normal" ) {
    res <- Rfast::colnormal.mle(x)
  } else if ( distr == "laplace" ) {
    res <- Rfast::collaplace.mle(x)
  } else if ( distr == "cauchy" ) {
    res <- Rfast2::colcauchy.mle(x, tol = tol, maxiters = maxiters, parallel = parallel)
  } else if ( distr == "gumbel" ) {
    res <- .colgumbel.mle(x, tol)
  } else if ( distr == "logistic" ) {
    res <- .collogistic.mle(x, tol)
  } else if ( distr == "ct" ) {
    res <- .colct.mle(x, tol)
  } else if ( distr == "t" ) {
    res <- .colt.mle(x, v, tol)
  } else if ( distr == 'wigner' ) {
    res <- .colwigner.mle(x, tol)
  } else if ( distr == 'cauchy0' ) {
    res <- .colcauchy0.mle(x, tol)
  } else if ( distr == 'gnormal0' ) {
    res <- .colgnormal0.mle(x, tol)
  } else if ( distr == "logisbeta" ) {
    res <- .collogisbeta.mle(x, tol = tol, maxiters = maxiters, parallel = parallel)
  }
  res
}



#------colGumbel----------------
.colgumbel.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::gumbel.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'location', 'scale')
  res
}

#-----collogistic--------------------
.collogistic.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::logistic.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'location', 'scale')
  res
}

#----colct-------
.colct.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::ct.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'nu', 'loglik')
  res
}

#-----colt-------
.colt.mle <- function(x, v, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::tmle(x[, i], v, tol) )
  colnames(res) <- c('iters', 'loglik', 'location','scatter')
  res
}

#----colwigner-------
.colwigner.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 2)
  for (i in 1:n)  res[i, ] <- unlist( Rfast::wigner.mle(x[, i], tol) )
  colnames(res) <- c('loglik', 'R')
  res
}

#----colcacuchy0-----
.colcauchy0.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 3)
  for (i in 1:n)  res[i, ] <- unlist( Rfast2::cauchy0.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik','scale')
  res
}

#---colgnormal0------
.colgnormal0.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for (i in 1:n)  res[i, ] <- unlist( Rfast2::gnormal0.mle(x[, i], tol) )
  colnames(res) <- c('iters', 'loglik', 'alpha','beta')
  res
}

.collogisbeta.mle <- function(x, tol = 1e-7, maxiters = 100, parallel = FALSE) {
  n <- dim(x)[1]
  ex <- exp(-x)
  y <- 1 / ( 1 + ex )
  res <- Rfast2::colbeta.mle(y, tol = tol, maxiters = maxiters, parallel = parallel)
  a <- res[, 1]  ;  b <- res[, 2]
  res[, 3] <-  - n * lbeta(a, b) - b * Rfast::colsums(x) - (a + b) * Rfast::colsums( log1p(ex) )
  res
}

colcens.mle <- function(x, distr = "censweibull", di, tol = 1e-07, parallel = FALSE, cores = 0) {
  if ( distr == "censweibull" ) {
    res <- Rfast2::colcensweibull.mle(x, di, tol = tol, parallel = parallel, cores = cores)
  } else if ( distr == "censpois" ) {
    res <- Rfast2::colcenspois.mle(x, tol = tol, parallel = parallel, cores = cores)
  } else if ( distr == 'tobit'){
    res <- .coltobit.mle(x, tol = tol)
  }
  res
}



#--------coltobit.mle--------------------------------
.coltobit.mle <- function(x, tol) {
  n <- dim(x)[2]
  res <- matrix(nrow = n, ncol = 4)
  for ( i in 1:n )  res[i, ] <- unlist( Rfast::tobit.mle(x, tol) )
  colnames(res) <- c('iters', 'loglik', 'location', 'scale')
  res
}

colcirc.mle <- function(x, distr = "vm", N = 2, ina, tol = 1e-07, maxiters = 100, parallel = FALSE) {
  if ( distr == "vm" ) {
    res <- Rfast::colvm.mle(x, tol = tol)
  } else if ( distr == "spml" ) {
    res <- Rfast2::colspml.mle(x, tol = tol, maxiters = maxiters, parallel = parallel)
  } else if ( distr == "purka" ) {
    res <- .colpurka.mle(x, tol = tol)
  } else if ( distr == "wrapcauchy" ) {
    res <- .colwrapcauchy.mle(x, tol = tol)
  } else if ( distr == "circexp" ) {
    res <- .colcircexp.mle(x, tol = tol)
  } else if ( distr == "circbeta" ) {
    res <- .colcircbeta.mle(x)
  } else if ( distr == "cardio" ) {
    res <- .colcardio.mle(x)
  } else if ( distr == "ggvm" ) {
    res <- .colggvm.mle(x)
  } else if ( distr == "cipc" ) {
    res <- .colcipc.mle(x, tol = tol)
  } else if ( distr == "gcpc" ) {
    res <- .colgcpc.mle(x)
  } else if ( distr == "mmvm" ) {
    res <- .colmmvm.mle(x, N = N)
  } else if ( distr == "multivm") {
    res <- .colmultivm.mle(x, ina = ina, tol = tol)
  } else if ( distr == "multispml" ) {
    res <- .colmultispml.mle(x, ina = ina, tol = tol)
  }
  res
}



.colpurka.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast2::purka.mle(x[, i]) )
  colnames(res) <- c("theta1", "theta2", "alpha", "loglik", "alpha.sd")
  res
}

.colwrapcauchy.mle <- function(x, tol = tol) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Rfast::wrapcauchy.mle(x[, i], tol = tol) )
  colnames(res) <- c("iters", "loglik", "direction", "param.rho")
  res
}

.colcircexp.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 2)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::circexp.mle(x[, i], rads = TRUE, tol = tol) )
  colnames(res) <- c("loglik", "lambda")
  res
}

.colcircbeta.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 4)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::circbeta.mle(x[, i], rads = TRUE) )
  colnames(res) <- c("loglik", "mean", "alpha", "beta")
  res
}

.colcardio.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::cardio.mle(x[, i], rads = TRUE) )
  colnames(res) <- c("loglik", "mu", "rho")
  res
}

.colgcpc.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 6)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::gcpc.mle(x[, i], rads = TRUE) )
  colnames(res) <- c("mu1", "mu2", "circmu", "gamma", "rho", "loglik")
  res
}

.colmmvm.mle <- function(x, N) {
  res <- matrix(NA, dim(x)[2], 3)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::mmvm.mle(x[, i], N[i], rads = TRUE) )
  colnames(res) <- c("mu", "kappa", "loglik")
  res
}

.colggvm.mle <- function(x) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::ggvm.mle(x[, i], rads = TRUE) )
  colnames(res) <- c("loglik", "Zeta","Kappa", "mu", "alpha")
  res
}

.colcipc.mle <- function(x, tol) {
  res <- matrix(NA, dim(x)[2], 5)
  for ( i in 1:dim(x)[2] )  res[i, ] <- unlist( Directional::cipc.mle(x[, i], rads = TRUE, tol = tol) )
  colnames(res) <- c("mu1", "mu2", "circmu", "gamma", "loglik")
  res
}

.colmultivm.mle <- function(x, ina, tol) {
  res <- matrix(NA, dim(x)[2], length( unique(ina) ) * 3 )
  for ( i in 1:dim(x)[2] ) {
    a <- unlist( Rfast2::multivm.mle(x[, i], ina, tol = tol, ell = TRUE) )
    res[i, ] <- a
  }
  colnames(res) <- attributes(a)$names
  res
}

.colmultispml.mle <- function(x, ina, tol) {
  res <- matrix(NA, dim(x)[2], length( unique(ina) ) * 3 + 1)
  for ( i in 1:dim(x)[2] ) {
    a <- unlist( Rfast2::multispml.mle(x[, i], ina, tol = tol, ell = TRUE) )
    res[i, ] <- a
  }
  colnames(res) <- attributes(a)$names
  res
}

real.mle <- function(x, distr = "normal", v = 5, tol = 1e-07) {
  if ( distr == "normal" ) {
    res <- Rfast::normal.mle(x)
    } else if ( distr == "gumbel" ) {
    res <- Rfast::gumbel.mle(x, tol = tol)
  } else if ( distr == "cauchy" ) {
    res <- Rfast::cauchy.mle(x, tol = tol)
  } else if ( distr == "logistic" ) {
    res <- Rfast::logistic.mle(x, tol  = tol)
  } else if ( distr == "ct" ) {
    res <- Rfast::ct.mle(x, tol = tol)
  } else if ( distr == "t" ) {
    res <- Rfast::tmle(x, v = v, tol = tol)
  } else if ( distr == "wigner" ) {
    res <- Rfast::wigner.mle(x, tol = tol)
  } else if ( distr == "laplace" ) {
    res <- Rfast::laplace.mle(x)
  } else if ( distr == "cauchy0") {
    res <- Rfast2::cauchy0.mle(x, tol = tol)
  } else if ( distr == "gnormal0" ) {
    res <- Rfast2::gnormal0.mle(x, tol = tol)
  } else if ( distr == "logisbeta" ) {
    res <- .logisbeta.mle(x, tol = tol)
  }
  res
 }


.logisbeta.mle <- function(x, tol = 1e-7) {
  n <- length(x)
  ex <- exp(-x)
  y <- 1 / ( 1 + ex )
  par <- Rfast::beta.mle(y, tol = tol)$param
  a <- par[1]  ;  b <- par[2]
  loglik <-  - n * lbeta(a, b) - b * sum(x) - (a + b) * sum( log1p(ex) )
  list(loglik = loglik, param = par)
}

circ.mle <- function(x, rads = FALSE, distr = "vm", N = 2, ina, tol = 1e-07, maxiters = 100) {
  if ( !rads )  x <- x * pi/180

  if ( distr == "vm" ) {
    res <- Rfast::vm.mle(x, tol = tol)
  } else if ( distr == "spml" ) {
    res <- Rfast::spml.mle(x, tol = tol, maxiters = maxiters)
  } else if ( distr == "purka" ) {
    res <- Rfast2::purka.mle(x, tol = tol)
  } else if ( distr == "wrapcauchy" ) {
    res <- Rfast::wrapcauchy.mle(x, tol = tol)
  } else if ( distr == "circexp" ) {
    res <- Directional::circexp.mle(x, rads = TRUE, tol = tol)
  } else if ( distr == "circbeta" ) {
    res <- Directional::circbeta.mle(x, rads = TRUE)
  } else if ( distr == "cardio" ) {
    res <- Directional::cardio.mle(x, rads = TRUE)
  } else if ( distr == "ggvm" ) {
    res <- Directional::ggvm.mle(x, rads = TRUE)
  } else if ( distr == "cipc" ) {
    res <- Directional::cipc.mle(x, rads = TRUE, tol = tol)
  } else if ( distr == "gcpc" ) {
    res <- Directional::gcpc.mle(x, rads = TRUE)
  } else if ( distr == "mmvm" ) {
    res <- Directional::mmvm.mle(x, N = N, rads = TRUE)
  } else if ( distr == "multivm") {
    res <- Rfast2::multivm.mle(x, ina, tol = tol, ell = TRUE)
  } else if ( distr == "multispml" ) {
    res <- Rfast2::multispml.mle(x, ina, tol = tol, ell = TRUE)
  }
  res
}

#!/bin/bash

if [ -z "$MLE" ]; then
    echo "Expected MLE env var defined"
    exit 1
fi

$MLE -v

for t in $(find . -mindepth 2 -type f -name 'test_*'); do
    [ -x "$t" ] || continue
    tshort=$(basename $t)
    tdir=$(dirname $t)
    tput bold 2>/dev/null; echo TEST $tshort; tput sgr0 2>/dev/null
    pushd $tdir &>/dev/null
    ./$tshort
    ec=$?
    popd &>/dev/null
    echo
    [ $ec -eq 0 ] && pass=$((pass+1))
    total=$((total+1))
done
printf "Passed %d out of %d tests\n" $pass $total
[ $pass -eq $total ] || exit 1

#!/usr/bin/env bash

MLE_ORIG=$MLE
export MLE="timeout -s KILL 2 $MLE_ORIG"

macro='a C-z'
extra_opts=(-u1) # coarse undo
declare -A expected
expected[no_inf_loop]='.'
source 'test.sh'

tmpf=$(mktemp)
finish() { rm -f $tmpf; }
trap finish EXIT
cat >$tmpf <<'EOD'
func apple() {
    // banana (ensure coarse undo works properly on very first user action)
} // carrot
EOD
byte_count=$(cat $tmpf | wc -c)
macro='C-e enter C-z'
extra_opts=(-u1 -i1 $tmpf) # coarse undo, auto indent
declare -A expected
expected[coarse_undo_1st_1]="apple"
expected[coarse_undo_1st_2]="banana"
expected[coarse_undo_1st_3]="carrot"
expected[coarse_undo_1st_c]="^bview.0.buffer.byte_count=$byte_count\$"
source 'test.sh'

export MLE="$MLE_ORIG"

#!/usr/bin/env bash

# make tmpf and delete at exit
tmpf=$(mktemp)
finish() { rm -f $tmpf; }
trap finish EXIT

# write >MLE_BRACKET_PAIR_MAX_SEARCH chars to tmpf
echo '('    >>$tmpf
seq 1 10000 >>$tmpf
echo ')'    >>$tmpf

# ensure cursor.sel_rule closed
macro='M-c right C-2 d'
extra_opts=($tmpf)
declare -A expected
expected[srule_should_be_closed]='^bview.0.cursor.0.sel_rule=n$'
source 'test.sh'

#!/usr/bin/env bash

on_exit() { [ -n "$lua_script" ] && rm -f $lua_script; }
trap on_exit EXIT
lua_script=$(mktemp 'mle.test_lua.XXXXXXXXXX')
extra_opts=(-x $lua_script -K lua_kmap,,1 -k cmd_lua_test,f11, -k cmd_quit_without_saving,f12, -n lua_kmap)

# mle.mark_insert_before
macro='f11'
cat >$lua_script <<"EOD"
mle.editor_register_cmd("cmd_lua_test", function (ctx)
    mle.mark_insert_before(ctx["mark"], "hello from lua\n", 15)
end)
EOD
declare -A expected
expected[simple_data]='^hello from lua$'
source 'test.sh'


# mle.editor_open_bview
macro='f11'
cat >$lua_script <<"EOD"
mle.editor_register_cmd("cmd_lua_test", function (ctx)
    print "hi1"
    mle.editor_open_bview(ctx["editor"], nil, 0, nil, 0, 1, 0, 0, nil)
    print "hi2"
end)
EOD
declare -A expected
expected[open_data1      ]='^hi1$'
expected[open_data2      ]='^hi2$'
expected[open_bview_count]='^bview_count=2$'
source 'test.sh'

# mle.editor_prompt
macro='f11 t e s t enter . . . f11 C-c'
cat >$lua_script <<"EOD"
mle.editor_register_cmd("cmd_lua_test", function (ctx)
    rv = mle.editor_prompt(ctx["editor"], "input?")
    if rv then
        str = "hello " .. rv .. " from lua"
    else
        str = "you hit ctrl-c"
    end
    mle.mark_insert_before(ctx["mark"], str, string.len(str))
end)
EOD
declare -A expected
expected[prompt_data]='^hello test from lua...you hit ctrl-c$'
source 'test.sh'

# mle.editor_register_observer
macro='f11'
cat >$lua_script <<"EOD"
mle.editor_register_cmd("cmd_lua_test", function (ctx)
    print "ell"
end)
mle.editor_register_observer("cmd:cmd_lua_test:before", function (ctx)
    print "h"
end)
mle.editor_register_observer("cmd:cmd_lua_test:after", function (ctx)
    print "o"
end)
EOD
declare -A expected
expected[observer_data]='^hello$'
source 'test.sh'

# mle.editor_register_observer
macro='f11 h i enter M-e s e q space 1 space 5 | p a s t e space - s d , space - enter backspace backspace'
cat >$lua_script <<"EOD"
mark = nil
in_callback = false
mle.editor_register_cmd("cmd_lua_test", function (ctx)
    mark = ctx["mark"]
    bview = mle.editor_open_bview(ctx["editor"], nil, 0, nil, 0, 1, 0, 0, nil)
    mle.editor_set_active(ctx["editor"], bview["optret_bview"])
end)
mle.editor_register_observer("buffer:baction", function (baction)
    if in_callback or not mark then return end
    in_callback = true
    str = "buffer=" .. baction["buffer"] .. " byte_delta=" .. baction["byte_delta"] .. "\n"
    mle.mark_insert_before(mark, str, string.len(str))
    in_callback = false
end)
EOD
declare -A expected
expected[observer_data1  ]='^hi$'
expected[observer_data2  ]='^1,2,3,4,$'
expected[observer_output1]='^buffer=[^ ]+ byte_delta=1$'  # typing
expected[observer_output1]='^buffer=[^ ]+ byte_delta=10$' # output from `seq 1 5 | paste -sd, -`
expected[observer_output1]='^buffer=[^ ]+ byte_delta=-1$' # backspacing
source 'test.sh'

#!/usr/bin/env bash

macro='o n e space t w o CS-left C-k o k'
declare -A expected
expected[temp_anchor_cut]='^one ok$'
source 'test.sh'

macro='o n e space t w o CS-left x C-k o k'
declare -A expected
expected[temp_anchor_cancel_cut]='^ok$'
source 'test.sh'

#!/usr/bin/env bash

macro='a b c enter d e f enter g h i enter M-\ M-a insert j k down C-k C-u'
declare -A expected
expected[acut_line1]='^  c$'
expected[acut_line2]='^  jk$'
expected[acut_line3]='^ghde$'
source 'test.sh'

macro='a b c enter d e f enter g h i enter M-\ M-a insert right right down M-k C-u'
declare -A expected
expected[acopy_line1]='^abc$'
expected[acopy_line2]='^deab$'
expected[acopy_line3]='^ghde$'
source 'test.sh'

macro='space a b enter enter space c d M-a insert M-; a M-k C-e C-u'
declare -A expected
expected[aspace_line1]='^ abab$'
expected[aspace_line2]='^ cdcd$'
source 'test.sh'

macro='a b c insert M-k C-u'
declare -A expected
expected[copy_line1]='^abc$'
expected[copy_line2]='^$'
expected[copy_count]='\.line_count=2$'
source 'test.sh'

macro='a b c insert C-k C-u'
declare -A expected
expected[cut_line1]='^   abc$'
expected[cut_line2]='^   $'
expected[cut_count]='\.line_count=2$'
source 'test.sh'

macro="a enter b enter c M-\ M-a insert M-/ C-/ ' x"
declare -A expected
expected[drop_line1]='^ax$'
expected[drop_line2]='^bx$'
expected[drop_line3]='^cx$'
expected[drop_count]='\.line_count=3$'
source 'test.sh'

macro="a a enter b b enter c c M-\ M-a insert M-/ C-/ ' M-a C-a C-k C-u"
declare -A expected
expected[adrop_line1]='^  aa$'
expected[adrop_line2]='^  bb$'
expected[adrop_line3]='^  cc$'
expected[adrop_line4]='^  $'
expected[adrop_count]='\.line_count=4$'
source 'test.sh'

#!/usr/bin/env bash

# cmd_move_(left|right|up|down)
macro='h e l l o enter w o r l d left up right down'
declare -A expected
expected[dpad_cursor_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[dpad_cursor_col ]='^bview.0.cursor.0.mark.col=5$'
source 'test.sh'

# cmd_move_(bol)
macro='h e l l o enter w o r l d C-a'
declare -A expected
expected[bol_cursor_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[bol_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_move_(eol)
macro='h e l l o enter w o r l d M-\ C-e'
declare -A expected
expected[eol_cursor_line]='^bview.0.cursor.0.mark.line_index=0$'
expected[eol_cursor_col ]='^bview.0.cursor.0.mark.col=5$'
source 'test.sh'

# cmd_move_(beginning,end)
macro='h e l l o enter w o r l d M-\ M-/'
declare -A expected
expected[beg_end_cursor_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[beg_end_cursor_col ]='^bview.0.cursor.0.mark.col=5$'
source 'test.sh'

# cmd_move_(to_line)
macro='0 enter 1 enter 2 enter 3 M-g 2 enter'
declare -A expected
expected[to_line_cursor_col]='^bview.0.cursor.0.mark.line_index=1$'
source 'test.sh'

# cmd_move_(to_relative)
macro='0 enter 1 enter 2 enter 3 enter M-y 2 u M-y 1 d'
declare -A expected
expected[relative_cursor_col]='^bview.0.cursor.0.mark.line_index=3$'
source 'test.sh'

# cmd_move_(until_forward|until_back)
macro="b a n a n a M-; b M-' a"
declare -A expected
expected[until_cursor_col]='^bview.0.cursor.0.mark.col=1$'
source 'test.sh'

# cmd_move_until_forward (nudge)
macro="a a C-a M-' a"
declare -A expected
expected[nudge_cursor_col]='^bview.0.cursor.0.mark.col=1$'
source 'test.sh'

# cmd_move_(word_forward|word_back)
macro='a p p l e space b a n a n a space c r a n M-b M-b M-f'
declare -A expected
expected[word_cursor_col]='^bview.0.cursor.0.mark.col=12$'
source 'test.sh'

# cmd_move_(bracket_forward|bracket_back)
macro='t e s t space { space { space { M-left M-left M-left M-right'
declare -A expected
expected[bracket_cursor_col]='^bview.0.cursor.0.mark.col=7$'
source 'test.sh'

# cmd_move_bracket_toggle
macro='t e s t 1 { enter t e s t 2 [ enter ] enter } M-= a M-= b'
declare -A expected
expected[bracket_toggle_line]='^bview.0.cursor.0.mark.line_index=2$'
expected[bracket_toggle_col ]='^bview.0.cursor.0.mark.col=1$'
expected[bracket_toggle_a   ]='^test2a\[$'
expected[bracket_toggle_b   ]='^b\]$'
source 'test.sh'

# cmd_jump
macro='a n t space b a t space c a t space d o g M-j a c'
declare -A expected
expected[jump_cursor_col]='^bview.0.cursor.0.mark.col=8$'
source 'test.sh'

#!/usr/bin/env bash

macro='1 0 space 2 0 space 3 0 C-r \ d + C-/ y e s C-/ /'
declare -A expected
expected[isearch_data        ]='^yes10 yes20 yes30$'
expected[isearch_cursor_count]='^bview.0.cursor_count=1$'
source 'test.sh'

macro='h i space C-/ . C-a C-/ a X X'
declare -A expected
expected[drop_wake_data        ]='^XXhi XX$'
expected[drop_wake_cursor_count]='^bview.0.cursor_count=2$'
source 'test.sh'

macro="o n e enter t w o enter t h r e e M-a M-\ C-/ ' C-e space a n d"
declare -A expected
expected[column_data1       ]='^one and$'
expected[column_data2       ]='^two and$'
expected[column_data3       ]='^three and$'
expected[column_cursor_count]='^bview.0.cursor_count=3$'
source 'test.sh'

macro="a enter space b enter space space c enter C-r \ S + C-/ C-/ l"
declare -A expected
expected[align_line_1]='^  a$'
expected[align_line_2]='^  b$'
expected[align_line_3]='^  c$'
source 'test.sh'

macro="a b enter c d enter e f enter C-r \ S + C-/ M-a C-e C-/ ; x"
declare -A expected
expected[swap_line_1]='^xab$'
expected[swap_line_2]='^xcd$'
expected[swap_line_2]='^xef$'
source 'test.sh'

macro="a b enter c d enter C-r \ S + C-/ M-a C-e M-."
declare -A expected
expected[indent_line_1]='^    ab$'
expected[indent_line_2]='^    cd$'
source 'test.sh'

macro="a enter b c enter d e f enter C-r \ S + C-/ M-a C-e M-e w c space - c enter"
declare -A expected
expected[shell_line_1]='^1$'
expected[shell_line_2]='^2$'
expected[shell_line_2]='^3$'
source 'test.sh'

#!/usr/bin/env bash

macro='f o o enter b a r backspace backspace backspace backspace'
declare -A expected
expected[bs_line1]='^foo$'
expected[bs_byte_count]='^bview.0.buffer.byte_count=3$'
expected[bs_line_count]='^bview.0.buffer.line_count=1$'
source 'test.sh'
unset expected

macro='f o o b a r left left left delete delete delete'
declare -A expected
expected[del_line1]='^foo$'
expected[del_byte_count]='^bview.0.buffer.byte_count=3$'
expected[del_line_count]='^bview.0.buffer.line_count=1$'
source 'test.sh'

macro='f o o space b a r C-w'
declare -A expected
expected[delete_word_back_data]='^foo $'
source 'test.sh'

macro='f o o space b a r C-a M-d'
declare -A expected
expected[delete_word_forward_data]='^ bar$'
source 'test.sh'

#!/usr/bin/env bash
if [ -n "$skip" ]; then
    echo -e "  \x1b[33mSKIP\x1b[0m $skip"
    unset skip
else
    actual=$(
        $MLE \
        -N \
        -H1 \
        -Qd \
        -K test_kmap,,1 \
        -k cmd_quit_without_saving,f12, \
        -n test_kmap \
        -M "test_macro $macro f12" \
        -p test_macro \
        "${extra_opts[@]}" \
        2>&1 >/dev/null
    );
    exit_code=$?

    if [ "$exit_code" -ne 0 ]; then
        echo -e "  \x1b[31mERR \x1b[0m nonzero_exit_code=$exit_code\n\n$actual"
        exit 1
    fi

    for testname in "${!expected[@]}"; do
        expected_re="${expected[$testname]}"
        if grep -Eq "$expected_re" <<<"$actual"; then
            echo -e "  \x1b[32mOK  \x1b[0m $testname"
        else
            echo -e "  \x1b[31mERR \x1b[0m $testname expected=$expected_re\n\n$actual"
            exit 1
        fi
    done

    unset expected
fi

#!/bin/bash
set -euxo pipefail

keyid='as@php.net'

die() { echo "$@" >&2; exit 1; }

sudo apt install -y \
    dh-make \
    devscripts \
    pbuilder \
    devscripts \
    lintian \
    $(awk '/Build-Depends/{$1=$2=$3=$4=""; print $0}' debian/control | tr -d ',')

{ gpg --list-keys | grep -q $keyid; } || die "Missing gpg key for $keyid"
[ -f /var/cache/pbuilder/base.tgz ] || sudo pbuilder create --debootstrapopts --variant=buildd

vers_maj_min_rel=$(head -n1 debian/changelog | awk '{print $2}' | tr -d '()')
vers_maj_min=$(echo $vers_maj_min_rel | cut -d- -f1)
tmpdir=$(mktemp -d --tmpdir 'mle.XXXXXXXXXX')
srcdir="$tmpdir/mle-$vers_maj_min"
mkdir $srcdir
cp -aT $(pwd) $srcdir
pushd $srcdir

git clean -fdx
git submodule foreach 'rm -rf *'
find . -name '.git*' | xargs rm -rf
rm debian.sh
rm -rf vendor
mkdir vendor
echo 'clean:' >vendor/Makefile

dh_make -s -y -c apache --createorig || true
debuild -i -us -uc -sa -S
debsign -k $keyid ../mle*.dsc
sudo pbuilder --build ../mle*.dsc

debsign -k $keyid --re-sign ../*.changes
lintian -i -I --show-overrides ../*.changes

popd

ls -l $tmpdir

# dput /tmp/.../*.changes

#!/usr/bin/env bash

macro='b e g i n space { enter l i n e 1 enter l i n e 2 enter } enter C-f l i n e 1 enter C-2 d'
declare -A expected
expected[sel_bracket_mark_line]='.mark.line_index=0$'
expected[sel_bracket_mark_col]='.mark.col=7$'
expected[sel_bracket_anchor_line]='.anchor.line_index=3$'
expected[sel_bracket_anchor_col]='.anchor.col=0$'
source 'test.sh'

macro='a b c enter l i n e 2 enter l i n e 3 C-2 q'
declare -A expected
expected[sel_all_mark_line]='.mark.line_index=2$'
expected[sel_all_mark_col]='.mark.col=5$'
expected[sel_all_anchor_line]='.anchor.line_index=0$'
expected[sel_all_anchor_col]='.anchor.col=0$'
source 'test.sh'

#!/usr/bin/env bash

# ensure binding in prev kmap works with fallthru enabled
extra_opts=(
    -K 'ka,,1' -k 'cmd_shell,a a,printf A' -k 'cmd_push_kmap,x,kb' -k 'cmd_quit_without_saving,f12,'
    -K 'kb,,1' -k 'cmd_shell,a b,printf B' -k 'cmd_pop_kmap,x,'
    -n 'ka'
)
macro='a a a b x a b a a x a z'
declare -A expected
expected[data_a]='^AabBAaz$'
source 'test.sh'

# ensure input trail resets on non-matching input w/ fallthru disabled
extra_opts=(
    -K 'ka,,0' -k 'cmd_shell,a,printf A' -k 'cmd_quit_without_saving,f12,'
    -n 'ka'
)
macro='b a'
declare -A expected
expected[data_b]='^A$'
source 'test.sh'

#!/usr/bin/env bash

macro='C-n'
declare -A expected
expected[new_bview_count]='^bview_count=2$'
source 'test.sh'

macro='C-n M-c'
declare -A expected
expected[close_bview_count]='^bview_count=1$'
source 'test.sh'

macro='a p p l e C-n b a n a n a'
declare -A expected
expected[new2_data1]='^apple$'
expected[new2_data2]='^banana$'
source 'test.sh'

macro='a p p l e C-n b a n a n a M-p r e d M-n y e l l o w'
declare -A expected
expected[next_prev_data1]='^applered$'
expected[next_prev_data2]='^bananayellow$'
source 'test.sh'

#!/usr/bin/env bash

extra_opts=(-M 'printable a A S-a M-a M-A MS-a C-a CS-a CM-a CMS-a enter comma tab f1' )
macro='M-< p r i n t a b l e enter'
declare -A expected
expected[printed_macro]='^a A S-a M-a M-A MS-a C-a CS-a CM-a CMS-a C-enter comma C-tab f1 $'
source 'test.sh'

#!/usr/bin/env bash

# skip if tree is not available
if ! command -v tree &>/dev/null; then
    skip='tree not in PATH'
    source 'test.sh'
    exit 0
elif ! tree --help | grep -q charset; then
    skip='tree version looks incorrect'
    source 'test.sh'
    exit 0
fi

# make tmpdir and delete at exit
this_dir=$(pwd)
tmpdir=$(mktemp -d)
cd $tmpdir
finish() { cd $this_dir; rm -rf $tmpdir; }
trap finish EXIT

# setup tmpdir
mkdir -p adir/bdir
touch adir/bdir/hi

# setup tmpdir with space in it (should be escaped)
mkdir -p 'a sp/b sp'
touch 'a sp/b sp/h i'

# ensure that we can browse into adir, bdir, then select hi
# ensure path is relative to where we started
macro='C-b C-f a d i r enter enter C-f b d i r enter enter C-f h i enter enter'
declare -A expected
expected[hi]='^bview.[[:digit:]]+.buffer.path=adir/bdir/hi$'
source "$this_dir/test.sh"

# ensure that we can browse into 'a sp', 'b sp', then select 'h i'
# ensure path is relative to where we started
macro='C-b C-f a space s p enter enter C-f b space s p enter enter C-f h space i enter enter'
declare -A expected
expected[hi_space]='^bview.[[:digit:]]+.buffer.path=a sp/b sp/h i$'
source "$this_dir/test.sh"

#!/usr/bin/env bash

extra_opts=(-t 10 -y syn_generic)
macro='tab h e l l o'
declare -A expected
expected[tab_line2]='^          hello$'
source 'test.sh'

extra_opts=(-t 10)
macro='tab h e l l o'
declare -A expected
expected[tab_line1]='^          hello$'
source 'test.sh'

#!/usr/bin/env bash

macro=''
extra_opts=(test_file_w_suffix test_file)
declare -A expected
expected[path_1]='^bview.[[:digit:]]+.buffer.path=test_file_w_suffix$'
expected[path_2]='^bview.[[:digit:]]+.buffer.path=test_file$'
source 'test.sh'

#!/usr/bin/env bash

macro='a p p l e C-z C-z'
declare -A expected
expected[undo_data]='^app$'
source 'test.sh'

macro='a p p l e C-z C-z C-y'
declare -A expected
expected[redo_data]='^appl$'
source 'test.sh'

#!/usr/bin/env bash

macro='f o o C-k'
declare -A expected
expected[cut_data]='^$'
source 'test.sh'

macro='f o o C-k C-u'
declare -A expected
expected[uncut_data]='^foo$'
source 'test.sh'

macro='f o o M-k C-u'
declare -A expected
expected[copy_data]='^foofoo$'
source 'test.sh'

macro='f o o M-a left left C-k'
declare -A expected
expected[sel_cut_data]='^f$'
source 'test.sh'

macro='f o o M-a left left C-k C-u'
declare -A expected
expected[sel_uncut_data]='^foo$'
source 'test.sh'

macro='f o o M-a left left M-k C-u'
declare -A expected
expected[sel_copy_data]='^foooo$'
source 'test.sh'

macro='a b c { x y z } C-f x y z enter C-d d C-e C-u'
declare -A expected
expected[cut_by_bracket_data]='^abc\{\}xyz$'
source 'test.sh'

macro='a b c space x y z left C-d w C-a C-u'
declare -A expected
expected[cut_by_word_data]='^xyzabc $'
source 'test.sh'

macro='a b c space x y z C-d s C-a C-u'
declare -A expected
expected[cut_by_word_back_data]='^xyzabc $'
source 'test.sh'

macro='a b c space x y z C-a C-d f C-e C-u'
declare -A expected
expected[cut_by_word_forward_data]='^ xyzabc$'
source 'test.sh'

macro='a b c space x y z C-d a C-u C-u'
declare -A expected
expected[cut_by_bol_data]='^abc xyzabc xyz$'
source 'test.sh'

macro='a b c space x y z C-a C-d e C-u C-u'
declare -A expected
expected[cut_by_eol_data]='^abc xyzabc xyz$'
source 'test.sh'

macro='a space " q u o t e d " space s t r i n g C-f u o t e enter C-d c'
declare -A expected
expected[cut_by_eol_data]='^a "" string$'
source 'test.sh'

macro='o n e - a b c M-a left left left C-k C-n t w o - C-u'
declare -A expected
expected[global_cut_buffer_data]='^two-abc$'
source 'test.sh'

macro='a b c C-2 e'
declare -A expected
expected[mark]='^bview.0.cursor.0.mark.col=3$'
expected[anchor]='^bview.0.cursor.0.anchor.col=3$'
source 'test.sh'

macro='a b c enter d e f M-\ M-a C-f f enter C-/ ; right C-k'
declare -A expected
expected[swap_anchor]='^af$'
source 'test.sh'

macro='a C-n b S-left M-k C-u M-p S-left M-k M-n CM-u'
declare -A expected
expected[buf1_data]='^a$'
expected[buf2_data]='^bab$'
source 'test.sh'

#!/usr/bin/env bash

extra_opts=(file42 file43)
macro='C-\ M-\ C-f f i l e 4 3 enter enter M-c'
declare -A expected
expected[bview_count   ]='^bview_count=2'
expected[bview_file42  ]='^bview.[[:digit:]]+.buffer.path=file42$'
expected[bview_headless]='^bview.[[:digit:]]+.buffer.path=$'
source "test.sh"

#!/usr/bin/env bash
tmpn=test_syntax_file
extra_opts=(-S syn_test,$tmpn,4,0 -s foo,,258,3 $tmpn)
macro='M-c f o o'
declare -A expected
expected[style_fg]='\bfg=258\b'
expected[style_bg]='\bbg=3\b'
source 'test.sh'

tmpn=test_syntax_file
extra_opts=(-S syn_test,$tmpn,4,0 -s foo,,1,2 $tmpn)
macro='M-c { enter f o o ; enter } enter M-\ M-a M-/ M-. M-a'
declare -A expected
expected[outdent_style]='<ch=102 fg=1 bg=2><ch=111 fg=1 bg=2><ch=111 fg=1 bg=2><ch=59 fg=0 bg=0>'
source 'test.sh'

on_exit() { [ -n "$tmpf" ] && rm -f $tmpf; }
trap on_exit EXIT
tmpf=$(mktemp 'mle.test_syntax.XXXXXXXXXX')

cat >$tmpf <<"EOD"
"aaa"
"aaa\\"
"aaa \" aaa"
"aaa"          bbb "aaa"
"aaa \" aaa"   bbb "aaa \" aaa"
"aaa \" aaa\\" bbb "aaa \" aaa\\"
"aaa"          bbb
"aaa\\"        bbb
"aaa \" aaa"   bbb
"aaa"          bbb "aaa"          bbb
"aaa \" aaa"   bbb "aaa \" aaa"   bbb
"aaa \" aaa\\" bbb "aaa \" aaa\\" bbb
bbb "aaa"          bbb
bbb "aaa\\"        bbb
bbb "aaa \" aaa"   bbb
bbb "aaa"          bbb "aaa"          bbb
bbb "aaa \" aaa"   bbb "aaa \" aaa"   bbb
bbb "aaa \" aaa\\" bbb "aaa \" aaa\\" bbb
EOD
extra_opts=(-yy $tmpf)
macro=''
declare -A expected
declare -A not_expected
# a==97 b==98
expected[style_dq_a]='<ch=97 fg=260\b'
expected[style_dq_b]='<ch=98 fg=0\b'
not_expected[style_dq_not_a]='<ch=97 fg=0\b'
not_expected[style_dq_not_b]='<ch=98 fg=260\b'
source 'test.sh'

cat >$tmpf <<"EOD"
"aa"         /*bb*/
"aa/*aa"     /*bb*/
"aa/*aa*/aa" /*bb*/
"aa"         /*bb*/
"aa/*aa"     /*bb"bb*/
"aa/*aa*/aa" /*bb"bb"bb*/
/*bb*/       "aa"
/*bb*/       "aa/*aa"
/*bb*/       "aa/*aa*/aa"
/*bb*/       "aa"
/*bb"bb*/    "aa/*aa"
/*bb"bb"bb*/ "aa/*aa*/aa"
EOD
extra_opts=(-yy $tmpf)
macro=''
declare -A expected
declare -A not_expected
# a==97 b==98
expected[style_sc_a]='<ch=97 fg=260\b'
expected[style_sc_b]='<ch=98 fg=7\b'
not_expected[style_sc_not_a]='<ch=97 fg=(0|7)\b'
not_expected[style_sc_not_b]='<ch=98 fg=(0|260)\b'
source 'test.sh'

cat >$tmpf <<"EOD"
# ccc
#
aaa "bbb" // ccc "ccc"
aaa "bbb" # ccc "ccc"
EOD
extra_opts=(-yy $tmpf)
macro=''
declare -A expected
declare -A not_expected
# a==97 b==98 c==99 #=35
expected[style_a]='<ch=97 fg=0\b'
expected[style_b]='<ch=98 fg=260\b'
expected[style_c]='<ch=99 fg=7\b'
expected[style_h]='<ch=35 fg=7\b'
not_expected[style_not_a]='<ch=97 fg=(260|7)\b'
not_expected[style_not_b]='<ch=98 fg=(0|7)\b'
not_expected[style_not_c]='<ch=99 fg=(0|260)\b'
not_expected[style_not_h]='<ch=35 fg=(0|260)\b'
source 'test.sh'

#!/usr/bin/env bash

# cmd_search
macro='h e l l o enter w o r l d C-f h e l l o enter'
declare -A expected
expected[search_cursor_line]='^bview.0.cursor.0.mark.line_index=0$'
expected[search_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_search_next
macro='h e l l o enter h e l l o C-f h e l l o enter C-g'
declare -A expected
expected[next_cursor_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[next_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_search_next (wrap)
macro='h e l l o enter h e l l o C-f h e l l o enter C-g C-g'
declare -A expected
expected[next_wrap_cursor_line]='^bview.0.cursor.0.mark.line_index=0$'
expected[next_wrap_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_find_word
macro='h e l l o enter h e l l o left C-v'
declare -A expected
expected[find_cursor_line]='^bview.0.cursor.0.mark.line_index=0$'
expected[find_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_find_word (wrap)
macro='h e l l o enter h e l l o left C-v C-v'
declare -A expected
expected[find_wrap_cursor_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[find_wrap_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_isearch
macro='a c t o r enter a p p l e enter a p p e t i t e enter a z u r e M-\ C-r a p p e enter'
declare -A expected
expected[isearch_cursor_line]='^bview.0.cursor.0.mark.line_index=2$'
expected[iesarch_cursor_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

# cmd_replace 1
macro='a 1 space b 2 space c 3 space d 4 C-t \ d + enter x enter y n a'
declare -A expected
expected[replace1_data]='^ax b2 cx dx$'
source 'test.sh'

# cmd_replace 2
macro='a 1 space b 2 space c 3 space d 4 C-t \ d + enter x enter y n C-c'
declare -A expected
expected[replace2_data]='^ax b2 c3 d4$'
source 'test.sh'

# cmd_replace 3
macro='a b c 1 2 3 C-t ( . . . ) ( . . . ) enter A $ 2 $ n B $ 1 $ n $ x 4 3 enter a'
declare -A expected
expected[replace3_data1]='^A123$'
expected[replace3_data2]='^Babc$'
expected[replace3_data3]='^C$'
source 'test.sh'

# cmd_search history
macro='h e l l o enter h e l l o C-f h e l l o enter C-f up enter'
declare -A expected
expected[history_line]='^bview.0.cursor.0.mark.line_index=1$'
expected[history_col ]='^bview.0.cursor.0.mark.col=0$'
source 'test.sh'

#!/usr/bin/env bash

macro='h e l l o enter w o r l d enter'
declare -A expected
expected[a_line1     ]='^hello$'
expected[a_line2     ]='^world$'
expected[a_byte_count]='^bview.0.buffer.byte_count=12$'
expected[a_line_count]='^bview.0.buffer.line_count=3$'
source 'test.sh'

macro='w o r l d M-i h e l l o'
declare -A expected
expected[b_line1     ]='^hello$'
expected[b_line2     ]='^world$'
expected[b_byte_count]='^bview.0.buffer.byte_count=11$'
expected[b_line_count]='^bview.0.buffer.line_count=2$'
source 'test.sh'

macro='h e l l o C-a M-u right M-u C-e M-u'
declare -A expected
expected[c_line1     ]='^hello$'
expected[c_lineb     ]='^$'
expected[c_line_count]='^bview.0.buffer.line_count=4$'
source 'test.sh'

#!/usr/bin/env bash

# cmd_indent
macro='h e l l o M-.'
declare -A expected
expected[indent_data]='^    hello$'
source 'test.sh'

# cmd_outdent
macro='space space space space h e l l o M-,'
declare -A expected
expected[outdent_data]='^hello$'
source 'test.sh'

# cmd_indent (sel)
macro='h e l l o enter w o r l d M-\ M-a M-/ M-.'
declare -A expected
expected[sel_indent_data1]='^    hello$'
expected[sel_indent_data2]='^    world$'
source 'test.sh'

# cmd_outdent (sel)
macro='space space space space h e l l o enter space space space space w o r l d M-\ M-a M-/ M-,'
declare -A expected
expected[sel_outdent_data1]='^hello$'
expected[sel_outdent_data2]='^world$'
source 'test.sh'

# _cmd_insert_auto_indent_*
macro='M-o a 0 enter f o r space { enter i = 1 enter } enter'
extra_opts=(-i 1)
declare -A expected
expected[auto_indent_1]='^for {$'
expected[auto_indent_2]='^'$'\t''i=1$'
expected[auto_indent_3]='^}$'
source 'test.sh'

\name{MLE of some circular distributions}
\alias{circ.mle}
\title{
MLE of some circular distributions
}

\description{
MLE of some circular distributions.
}

\usage{
circ.mle(x, rads = FALSE, distr = "vm", N = 2, ina, tol = 1e-07, maxiters = 100)
}

\arguments{
\item{x}{
A numerical vector with the circular data. They must be expressed in radians. If distr is "spml" or "purka" this can also be a matrix with two columns, the cosinus and the sinus of the circular data.
}
\item{rads}{
If the data are in radians set this to TRUE.
}
\item{distr}{
The type of distribution to fit, "vm" stands for the von Mises, "spml" is the angular Gaussian, "purka" is the Purkayastha, and "wrapcauchy" is the wrapped Cauchy distribution, "circexp" and "circbeta" stand for the circular exponential and the circular beta distributions, respectively. "cardio" is the cardioid distribution and "ggvm" is the generalized von Mises distribution, "cipc" is the circular independent projected Cauchy, "gcpc" is the generalised circular projected Cauchy distribution and "mmvm" is the multi-modal von Mises distribution. "multivm" and "multispml" denote the von Mises and the angular Gaussian but for multiple samples.
}
\item{N}{
The number of modes to consider in the multi-modal von Mises distribution.
}
\item{ina}{
A numerical vector with discrete numbers starting from 1, i.e. 1, 2, 3, 4,... or a factor variable. Each number denotes a sample or group. If you supply a continuous valued vector the function will obviously provide wrong results. This is only for "multivm" and "multispml".
}
\item{tol}{
The tolerance level to stop the iterative process of finding the MLEs.
}
\item{maxiters}{
The maximum number of iterations to implement.
}
}

\details{
The parameters of the bivariate angular Gaussian, wrapped Cauchy, circular exponential,
cardioid, circular beta, geometrically generalised von Mises, CIPC (reparametrised version of the
wrapped Cauchy), GCPC (generalisation of the CIPC) and multi-modal von Mises distributions are
estimated. For the Wrapped Cauchy, the iterative procedure described by Kent and Tyler (1988) is
used. The Newton-Raphson algortihm for the angular Gaussian is described in the regression setting
in Presnell et al. (1998). The circular exponential is also known as wrapped exponential distribution.
}

\value{
A list including:
\item{iters}{
The iterations required until convergence. This is returned in the wrapped Cauchy distribution only.
}
\item{param}{
A vector consisting of the estimates of the two parameters, the mean direction for both distributions and the concentration parameter \eqn{\kappa} and the \eqn{\rho} for the von Mises (and the multi-modal von Mises) and wrapped Cauchy respectively. For the circular beta this contains the mean angle and the \eqn{\alpha} and \eqn{\beta} parameters. For the cardioid distribution this contains the \eqn{\mu} and \eqn{\rho} parameters. For the generalised von Mises this is a vector consisting of the \eqn{\zeta}, \eqn{\kappa}, \eqn{\mu} and \eqn{\alpha} parameters of the generalised von Mises distribution as described in Equation (2.7) of Dietrich and Richter (2017).
}
\item{gamma}{
The norm of the mean vector of the angular Gaussian, the CIPC and the GCPC distributions.
}
\item{mu}{
The mean vector of the angular Gaussian, the CIPC and the GCPC distributions.
}
\item{mumu}{
In the case of "angular Gaussian distribution this is the mean angle in radians.
}
\item{circmu}{
In the case of the CIPC and the GCPC this is the mean angle in radians.
}
\item{rho}{
For the GCPC distribution this is the eigenvalue of the covariance matrix, or the covariance determinant.
}
\item{lambda}{
The lambda parameter of the circular exponential distribution.
}
\item{theta}{
The median direction of the Purkayastha distribution.
}
\item{alpha}{
The concentration parameter of the Purkayastha distribution.
}
\item{alpha.sd}{
The standard error of the concentration parameter of the Purkayastha distribution.
}
\item{loglik}{
The log-likelihood.
}
}

\references{
Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Sra S. (2012). A short note on parameter approximation for von Mises-Fisher distributions:
and a fast implementation of \eqn{I_s(x)}. Computational Statistics, 27(1): 177--190.

Presnell Brett, Morrison Scott P. and Littell Ramon C. (1998). Projected multivariate linear models for directional data. Journal of the American Statistical Association, 93(443): 1068--1077.

Kent J. and Tyler D. (1988). Maximum likelihood estimation for the wrapped Cauchy distribution.
Journal of Applied Statistics, 15(2): 247--254.

Dietrich T. and Richter W. D. (2017). Classes of geometrically generalized von Mises distributions.
Sankhya B, 79(1): 21--59.

https://en.wikipedia.org/wiki/Wrapped_exponential_distribution

Jammalamadaka S. R. and Kozubowski T. J. (2003). A new family of circular models:
The wrapped Laplace distributions.
Advances and Applications in Statistics, 3(1), 77--103.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics (accepted for publication).
https://arxiv.org/pdf/2302.02468.pdf

Barnett M. J. and Kingston R. L. (2024). A note on the Hendrickson-Lattman phase probability
distribution and its equivalence to the generalized von Mises distribution.
Journal of Applied Crystallography, 57(2).

Purkayastha S. (1991). A Rotationally Symmetric Directional Distribution: Obtained through Max-
imum Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83.

Cabrera J. and Watson G. S. (1990). On a spherical median related distribution. Communications
in Statistics-Theory and Methods, 19(6): 1973--1986
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{colcirc.mle},
}
}

\examples{
x <- runif(100, 0, 2*pi)
res <- circ.mle(x, distr = "wrapcauchy")
}

\name{MLE of continuous univariate distributions defined on the real line}
\alias{real.mle}
\title{
MLE of continuous univariate distributions defined on the real line}

\description{
MLE of continuous univariate distributions defined on the real line.
}

\usage{
real.mle(x, distr = "normal", v = 5, tol = 1e-7)
}

\arguments{
\item{x}{
A numerical vector with data.
}
\item{distr}{
The distribution to fit, "normal" stands for the normal distribution, "gumbel" for the Gumbel, "cauchy" for the Cauchy, "logistic" for the logistic distribution, "ct" for the (central) t distribution, "t" for the (non-central) t distribution, "wigner" is the Wigner semicircle distribution and "laplace" is the Laplace distribution. "cauchy0" and "gnormal0" are the Cauchy and generalised normal distributions, respectively, with zero location. The generalised normal distribution is also known as the exponential power distribution or the generalized error distribution.
}
\item{v}{
The degrees of freedom of the t distribution.
}
\item{tol}{
The tolerance level up to which the maximisation stops set to 1e-07 by default.
}
}

\details{
Instead of maximising the log-likelihood via a numerical optimiser we have used a Newton-Raphson algorithm which is faster. See wikipedia for the equation to be solved. For the t distribution we need the degrees of freedom and estimate the location and scatter parameters.

The Cauchy is the t distribution with 1 degree of freedom. The Laplace distribution is also called
double exponential distribution.
}

\value{
Usually a list with three elements, but this is not for all cases.
\item{iters}{
The number of iterations required for the Newton-Raphson to converge.
}
\item{scale}{
The estimated scale parameter of the Cauchy distribution.
}
\item{loglik}{
The value of the maximised log-likelihood.
}
\item{param}{
The vector of the parameters.
}
}

\references{
N.L. Johnson, S. Kotz and N. Balakrishnan (1994). Continuous Univariate Distributions, Volume 1 (2nd Edition).

N.L. Johnson, S. Kotz a nd N. Balakrishnan (1970). Distributions in statistics: continuous univariate
distributions, Volume 2.

https://en.wikipedia.org/wiki/Wigner_semicircle_distribution

Do M.N. and Vetterli M. (2002). Wavelet-based Texture Retrieval Using Generalised Gaussian Density
and Kullback-Leibler Distance. Transaction on Image Processing. 11(2): 146--158.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{positive.mle}, \link{circ.mle}, \link{disc.mle}
}
}

\examples{
x <- rnorm(1000, 10, 2)
a <- real.mle(x, distr = "normal")
}

\name{MLE of distributions defined in the (0, 1) interval}
\alias{prop.mle}
\title{
MLE of distributions defined in the (0, 1) interval
}

\description{
MLE of distributions defined in the (0, 1) interval.
}

\usage{
prop.mle(x, distr = "beta", tol = 1e-07, maxiters = 50)
}

\arguments{
\item{x}{
A numerical vector with proportions, i.e. numbers in (0, 1) (zeros and ones are not allowed).
}
\item{distr}{
The distribution to fit. "beta" stands for the beta distribution, "logitnorm" is the logistic normal,
"unitweibull" is the unit-Weibull and the "sp" is the standard power distribution, "ibeta" is the
inflated beta, (0-inflated or 1-inflated, depending on the data), "hsecant01" stands for the hyper-secant,
"kumar" is the Kumaraswamy, "simplex" is the simplex distribution, "zil" is the zero inflated logistic normal,
"cbern" is the continuous Bernoulli distribution and "logisbeta" is the logistic-beta distribution, and
"garcsine" is the generalised arcsine distribution.
}
\item{tol}{
The tolerance level up to which the maximisation stops.
}
\item{maxiters}{
The maximum number of iterations to implement.
}
}

\details{
Maximum likelihood estimation of the parameters of the beta distribution is performed via Newton-Raphson. The distributions and hence the functions does not accept zeros. "logitnorm" fits the logistic normal, hence no nwewton-Raphson is required and the "hypersecant01" uses the golden ratio search as is it faster than the Newton-Raphson (less calculations). The distributions included are the Kumaraswamy, zero inflated logistic normal, simplex, unit Weibull and continuous Bernoulli and standard power. Instead of maximising the log-likelihood via a numerical optimiser we have used a Newton-Raphson algorithm which is faster. See wikipedia for the equations to be solved.
}

\value{
A list including:
\item{iters}{
The number of iterations required by the Newton-Raphson.
}
\item{loglik}{
The value of the log-likelihood.
}
\item{param}{
The estimated parameters. In the case of "hypersecant01.mle" this is called
"theta" as there is only one parameter.
}
}

\references{
Kumaraswamy P. (1980). A generalized probability density function for double-bounded
random processes. Journal of Hydrology 46(1-2): 79--88.

Jones M.C. (2009). Kumaraswamy's distribution: A beta-type distribution with some
tractability advantages. Statistical Methodology, 6(1): 70--81.

J. Mazucheli, A. F. B. Menezes, L. B. Fernandes, R. P. de Oliveira and M. E. Ghitany (2020).
The unit-Weibull distribution as an alternative to the Kumaraswamy distribution for the modeling of quantiles conditional on covariates. Journal of Applied Statistics, 47(6): 954--974.

Leemis L.M. and McQueston J.T. (2008). Univariate Distribution Relationships.
The American Statistician, 62(1): 45--53.

You can also check the relevant wikipedia pages.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{ \link{colprop.mle}, \link{comp.mle}
}
}

\examples{
x <- rbeta(1000, 1, 4)
prop.mle(x, distr = "beta")
}

\name{Column-wise MLE of distributions defined in the (0, 1) interval}
\alias{colprop.mle}
\title{
Column-wise MLE of distributions defined in the (0, 1) interval
}

\description{
Column-wise MLE of distributions defined in the (0, 1) interval.
}

\usage{
colprop.mle(x, distr = "beta", tol = 1e-07, maxiters = 100, parallel = FALSE)
}

\arguments{
\item{x}{
A numerical vector with proportions, i.e. numbers in (0, 1) (zeros and ones are not allowed).
}
\item{distr}{
The distribution to fit. "beta" stands for the beta distribution, "logitnorm" is the logistic normal,
"unitweibull" is the unit-Weibull and the "sp" is the standard power distribution, "ibeta" is the
inflated beta, (0-inflated or 1-inflated, depending on the data), "hsecant01" stands for the hyper-secant,
"kumar" is the Kumaraswamy, "simplex" is the simplex distribution, "zil" is the zero inflated logistic normal,
"cbern" is the continuous Bernoulli distribution, and "logisbeta" is the logistic-beta distribution, and
"garcsine" is the generalised arcsine distribution.
}
\item{tol}{
The tolerance level up to which the maximisation stops.
}
\item{maxiters}{
The maximum number of iterations the Newton-Raphson will perform.
}
\item{parallel}{
Should the computations take place in parallel? This is for the "spml" only.
}
}

\details{
Maximum likelihood estimation of the parameters of the beta distribution is performed via Newton-Raphson.
The distributions and hence the functions does not accept zeros. "logitnorm.mle" fits the logistic normal,
hence no nwewton-Raphson is required and the "hypersecant01.mle" uses the golden ratio
search as is it faster than the Newton-Raphson (less calculations).
}

\value{
A matrix with two, columns. The first one contains the parameters of the distribution
and the second columns contains the log-likelihood values.
}

\references{
N.L. Johnson, S. Kotz and N. Balakrishnan (1994). Continuous Univariate Distributions, Volume 1 (2nd Edition).

N.L. Johnson, S. Kotz and N. Balakrishnan (1970). Distributions in statistics: continuous univariate distributions, Volume 2.

Kumaraswamy P. (1980). A generalized probability density function for double-bounded
random processes. Journal of Hydrology 46(1-2): 79--88.

Jones M.C. (2009). Kumaraswamy's distribution: A beta-type distribution with some
tractability advantages. Statistical Methodology, 6(1): 70--81.

J. Mazucheli, A. F. B. Menezes, L. B. Fernandes, R. P. de Oliveira and M. E. Ghitany (2020).
The unit-Weibull distribution as an alternative to the Kumaraswamy distribution for the modeling of quantiles conditional on covariates. Journal of Applied Statistics, 47(6): 954--974.

Leemis L.M. and McQueston J.T. (2008). Univariate Distribution Relationships.
The American Statistician, 62(1): 45--53.

You can also check the relevant wikipedia pages.
}


\author{
Michail Tsagris, Sofia Piperaki and Rafail Vargiakakis.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}, Sofia Piperaki  \email{sofiapip23@gmail.com} and Rafail Vargiakakis \email{rafailvargiakakis@gmail.com}.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{ \link{prop.mle}, \link{positive.mle}
}
}

\examples{
x <- rbeta(1000, 1, 4)
prop.mle(x, distr = "beta")
}

\name{MLE of distributions for compositional data}
\alias{comp.mle}
\title{
MLE of distributions for compositional data
}

\description{
MLE of distributions for compositional data.
}

\usage{
comp.mle(x, distr = "diri", type = 1, a = NULL, tol = 1e-07)
}

\arguments{
\item{x}{
A matrix containing the compositional data. Zero values are not allowed except for the case of the ZAD which is designed for the case of zero values present.
}
\item{distr}{
The distribution to fit. "diri" stands for the Dirichlet distribution, "zad" is the Zero Adjusted Dirichlet distribution and "afolded" for the \eqn{\alpha}-folded model (Tsagris and Stewart, 2020).
}
\item{type}{
This is for the Dirichlet distribution ("diri"). Type 1 uses a vectorised version of the Newton-Raphson (Minka, 2012). In high dimensions this is to be preferred. If the data are too concentrated, regardless of the dimensions, this is also to be preferrred. Type 2 uses the regular Newton-Raphson, with matrix multiplications. In small dimensions this can be considerably faster.
}
\item{a}{
The value of \eqn{\alpha}. If this is NULL, the function will estimate it internally.
}
\item{tol}{
The tolerance level idicating no further increase in the log-likelihood.
}
}

\details{
Maximum likelihood estimation of the parameters of a Dirichlet distribution is performed via Newton-Raphson.
Initial values suggested by Minka (2012) are used.
}

\value{
A list including:
\item{loglik}{
The value of the log-likelihood.
}
\item{param}{
The estimated parameters.
}
\item{phi}{
The precision parameter. If covariates are linked with it (function "diri.reg2"), this will
be a vector.
}
\item{mu}{
The mean vector of the distribution.
}
\item{runtime}{
The time required by the MLE.
}
\item{best}{
The estimated optimal \eqn{\alpha} of the folded model.
}
\item{p}{
The estimated probability inside the simplex of the folded model.
}
\item{mu}{
The estimated mean vector of the folded model.
}
\item{su}{
The estimated covariance matrix of the folded model.
}
}

\references{
Minka Thomas (2012). Estimating a Dirichlet distribution. Technical report.

Ng Kai Wang, Guo-Liang Tian, and Man-Lai Tang (2011). Dirichlet and related distributions: Theory, methods and applications. 
John Wiley & Sons.

Tsagris M. and Stewart C. (2018). A Dirichlet regression model for compositional data with zeros.
Lobachevskii Journal of Mathematics, 39(3): 398--412.
Preprint available from https://arxiv.org/pdf/1410.5011.pdf

Tsagris M. and Stewart C. (2022). A Review of Flexible Transformations for Modeling Compositional Data. 
In Advances and Innovations in Statistics and Data Science, pp. 225--234.
https://link.springer.com/chapter/10.1007/978-3-031-08329-7_10

Tsagris M. and Stewart C. (2020). A folded model for compositional data analysis. 
Australian and New Zealand Journal of Statistics, 62(2): 249--277. https://arxiv.org/pdf/1802.07330.pdf
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{\link{prop.mle}
}
}

\examples{
x <- matrix( rgamma(100 * 4, c(5, 6, 7, 8), 1), ncol = 4)
x <- x / rowSums(x)
res <- comp.mle(x)
}

\name{MLE of some truncated distributions}
\alias{truncmle}

\title{MLE of some truncated distributions
}

\description{
MLE of some truncated distributions.
}

\usage{
truncmle(x, distr = "trunccauchy", a, b, tol = 1e-07)
}

\arguments{
\item{x}{
A numerical vector with continuous data. For the Cauchy distribnution, they can be anywhere on the real line. For the exponential distribution they must be strictly positive.
}
\item{distr}{
The type of distribution to fit, "trunccauchy" and "truncexpmle" stand for the truncated Cauchy and truncated exponential distributions, respectively.
}
\item{a}{
The lower value at which the Cauchy distribution is truncated.
}
\item{b}{
The upper value at which the Cauchy or the exponential distribution is truncated. For the exponential this must
be greater than zero.
}
\item{tol}{
The tolerance value to terminate the fitting algorithm.
}
}

\details{
Maximum likelihood of some truncated distributions is performed.
}

\value{
A list including:
\item{iters}{
The number of iterations reuired by the Newton-Raphson algorithm.
}
\item{loglik}{
The log-likelihood.
}
\item{lambda}{
The \eqn{\lambda} parameter in the exponential distribution.
}
\item{param}{
The location and scale parameters in the Cauchy distribution.
}
}

\references{
David Olive (2018). Applied Robust Statistics (Chapter 4).

http://lagrange.math.siu.edu/Olive/ol-bookp.htm
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{cens.mle}
}
}

\examples{
x <- rnorm(500)
truncmle(x, a = -1, b = 1)
}

\name{MLE-package}
\alias{MLE-package}
\docType{package}
\title{
Maximum Likelihood Estimation of Various Univariate and Multivariate Distributions
}
\description{
The package offers functions for the maximum likelihood estimation of various univariate and multivariate distributions. The list includes univariate continuous and discrete distributions, distributions that lie on the real line, the positive line, interval restricted, circular distributions. Further, multivariate continuous and discrete distributions, distributions for compositional and directional data, etc. The references are included within each set of functions.
}
\details{
\tabular{lll}{
Package: \tab MLE\cr
Type: \tab Package\cr
Version: \tab 1.9\cr
Date: \tab 2026-08-25\cr
License: \tab GPL-2\cr
}
}
\author{
Michail Tsagris \email{mtsagris@uoc.gr}, Sofia Piperaki \email{sofiapip23@gmail.com},
Muhammad Imran \email{imranshakoor84@yahoo.com}, Rafail Vargiakakis \email{rafailvargiakakis@gmail.com}
and Nikolaos Kontemeniotis \email{kontemeniotisn@gmail.com}.
}

\section{Maintainers}{
Michail Tsagris \email{mtsagris@uoc.gr}.
}

%\references{
%}

\name{MLE of some censored models}
\alias{cens.mle}
\title{
MLE of some censored models
}

\description{
MLE of some censored models.
}

\usage{
cens.mle(x, distr = "tobit", di, tol = 1e-07)
}

\arguments{
\item{x}{
A vector with positive valued data and zero values. If there are no zero values, a simple normal model is fitted in the end.
}
\item{distr}{
The distribution to fit. "tobit" stands for the tobit model, "censweibull" for the censored Weibull and "censpois" for the left censored Poisson. For the "censpois" the lowest value in x is taken as the censored point and values below that number are considered to be censored.
}
\item{di}{
A vector of 0s (censored) and 1s (not censored) values.
}
\item{tol}{
The tolerance level up to which the maximisation stops; set to 1e-07 by default.
}
}

\details{
The tobin model is useful for (univariate) positive data with left censoring at zero. There is the assumption of a latent variable. Tthe values of that variable which are positive concide with the observed values. If some values are negative, they are left censored and the observed values are zero. Instead of maximising the log-likelihood via a numerical optimiser we have used a Newton-Raphson algorithm which is faster.
}

\value{
A list including:
\item{iters}{
The number of iterations required for the Newton-Raphson to converge.
}
\item{loglik}{
The value of the maximised log-likelihood.
}
\item{param}{
The vector of the parameters.
}
}

\references{
Tobin James (1958). Estimation of relationships for limited dependent variables. Econometrica. 26(1):24--36.

https://en.wikipedia.org/wiki/Tobit_model

Fritz Scholz (1996). Maximum Likelihood Estimation for Type I Censored Weibull Data Including Covariates.
Technical report. ISSTECH-96-022, Boeing Information & Support Services, P.O. Box 24346, MS-7L-22.

}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{colcens.mle}, \link{positive.mle}, \link{truncmle}
}
}

\examples{
x <- rnorm(300, 3, 5)
x[ x < 0 ] <- 0   ## left censoring. Values below zero become zero
cens.mle(x, distr = "tobit")

x1 <- rpois(10000, 15)
x <- x1
x[x <= 10] <- 10
mean(x) ## simple Poisson
cens.mle(x, distr = "censpois")$lambda

}

\name{MLE of some matrix distributions}
\alias{matrix.mle}
\title{
MLE of some matrix distributions
}

\description{
MLE of some matrix distributions some matrix distributions.
}

\usage{
matrix.mle(X, distr = "MN")
}

\arguments{
\item{X}{
For the matrix normal, a list with k elements (k is the sample size), k matrices of dimension
\eqn{n \times p} each. For the matrix Fisher an array containing rotation matrices in SO(3).
}
\item{distr}{
The distribution to fit. "MN" stands for the matrix normal, while "mfisher" stands for the matrix Fisher distribution (defined in SO(3)).
}
}

\value{
For the matrix normal a list including:
\item{runtime}{
The runtime required for the whole fitting procedure.
}
\item{iters}{
The number of iterations required for the estimation of the U and V matrices.
}
\item{M}{
The estimated mean matrix of the distribution, a numerical matrix of dimensions \eqn{n \times p}.
}
\item{U}{
The estimated covariance matrix associated with the rows, a numerical matrix of dimensions \eqn{n \times n}.
}
\item{V}{
The estimated covariance matrix associated with the columns, a numerical matrix of dimensions \eqn{p \times p}.
}
For the matrix Fisher the components of \eqn{ svd( \bar{X} ) }.
}

\references{
Pocuca N., Gallaugher M. P., Clark K. M. and McNicholas P. D. (2019). Assessing and Visualizing Matrix Variate Normality. arXiv:1910.02859.

https://en.wikipedia.org/wiki/Matrix_normal_distribution#Definition

Prentice M. J. (1986). Orientation statistics without parametric assumptions.
Journal of the Royal Statistical Society. Series B (Methodological), 48(2): 214--222.
}

\author{
Michail Tsagris.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}.
}

\seealso{
\code{\link{mv.mle}, \link{hspher.mle}
}
}

\examples{
## silly example
n <- 8  ;  p <- 4
X <- list()
for ( i in 1:200 )
X[[ i ]] <- matrix( rnorm(n * p), ncol = p )
mod <- matrix.mle(X)
}

\keyword{ Matrix Fisher distribution }
\keyword{ Maximum likelihood estimation }

\name{MLE of count data (univariate discrete distributions)}
\alias{disc.mle}
\title{
MLE of count data
}

\description{
MLE of count data.
}

\usage{
disc.mle(x, distr = "poisson", N = NULL, type = 1, tol = 1e-07)
}

\arguments{
\item{x}{
A vector with discrete valued data.
}
\item{distr}{
The distribution to fit, "poisson" stands for the Poisson, "zip" for the zero-inflated Poisson,
"ztp" for the zero-truncated Poisson, "negbin" for the negative binomial, "binom" for the binomial,
"borel" for the Borel distribution, "geom" for the geometric, "logseries" for the log-series distribution,
"betageom" for the beta-geometric, "betabinom" for the beta-binomial distribution,
"skellam" for the Skellam distribution, "gp" for the generalised Poisson distribution,
"gammapois" for the gamma-Poisson distribution, "cc" for the Cacoullos-Cauchy distribution,
"cc0" for the Cacoullos-Cauchy distribution with zero location, "com-pois" for the Conway-Maxwell Poisson
(COM-Poisson), and "zicom-pois" for the zero inflated COM-Poisson distribution. "tppxg" and "tpxg" refer
to the two-parameter Poisson Xgamma and the two-parameter Xgamma distribution, respectively.
}
\item{N}{
This is for the binomial distribution only, specifying the total number of successes. If NULL, it is sestimated by the data. It can also be a vector of successes.
}
\item{type}{
This argument is for the negative binomial and the geometric distribution.
In the negative binomial you can choose which way your prefer. Type 1 is for smal sample sizes, whereas
type 2 is for larger ones as is faster. For the geometric it is related to its two forms. Type 1 refers to the case where the minimum is zero and type 2 for the case of the minimum being 1.
}
\item{tol}{
The tolerance level up to which the maximisation stops set to 1e-07 by default.
}
}

\details{
Instead of maximising the log-likelihood via a numerical optimiser we used a Newton-Raphson algorithm which is faster.

See wikipedia for the equation to be solved in the case of the zero inflated distribution. https://en.wikipedia.org/wiki/Zero-inflated_model.
In order to avoid negative values we have used link functions, log for the \eqn{lambda} and logit for the \eqn{\pi} as suggested by Lambert (1992).
As for the zero truncated Poisson see https://en.wikipedia.org/wiki/Zero-truncated_Poisson_distribution.
}

\value{
The following list is not inclusive of all cases. Different functions have different names. In general a list including:
\item{mess}{
This is for the negbin.mle only. If there is no reason to use the negative binomial distribution a message will appear, otherwise this is NULL.
}
\item{iters}{The number of iterations required for the Newton-Raphson to converge.
}
\item{loglik}{The value of the maximised log-likelihood.
}
\item{prob}{The probability parameter of the distribution. In some distributions this argument might have a different name.
For example, param in the zero inflated Poisson.
}
}

\references{
Lambert D. (1992). Zero-Inflated Poisson Regression, with an Application to Defects in
Manufacturing. Technometrics. 34 (1): 1--14

Johnson N. L., Kotz S. and Kemp A. W. (1992). Univariate Discrete
Distributions (2nd ed.). Wiley.

Skellam J. G. (1946) The frequency distribution of the difference between two Poisson variates belonging to different populations.
Journal of the Royal Statistical Society, series A 109/3, 26.

Nikoloulopoulos A.K. and Karlis D. (2008). On modeling count data: a comparison of some well-known discrete distributions. Journal of Statistical Computation and Simulation, 78(3): 437--457.

Papadatos N. (2022). The characteristic function of the discrete Cauchy distribution In Memory of T. Cacoullos. Journal of Statistical Theory and Practice, 16(3): 47.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{real.mle}
}
}

\examples{
x <- rpois(100, 2)
disc.mle(x, type = "poisson")
}

\name{MLE of continuous univariate distributions defined on the positive line}
\alias{positive.mle}
\title{
MLE of continuous univariate distributions defined on the positive line}

\description{
MLE of continuous univariate distributions defined on the positive line.
}

\usage{
positive.mle(x, distr = "gamma", tol = 1e-07, maxiters = 100)
}

\arguments{
\item{x}{
A vector with positive valued data (zeros are not allowed).
}
\item{distr}{
The distribution to fit. "gamma" stands for the gamma distribution, "chisq" for the \eqn{\chi^2} distribution,
"weibull" for the Weibull, "lomax" for the Lomax, "foldnorm" for the folded normal,
"betaprime" for the beta-prime distribution, "lognorm" for the log-normal, "logcauchy" for the log-Cauchy,
"loglogictic" for the log-logistic distribution. "halfnorm" for the half-normal, "invgauss" for the inverse
Gaussian, "pareto" for the Pareto distribution, "exp" for the exponential distribution,
"exp2" I do not remember, "maxboltz" for the Maxwell-Boltzman distribution, "rayleigh" is the Rayleigh
distribution, "lindley" is the Lindley distribution, "halfcauchy" is the half-Cauchy distribution and
"powerlaw" is the power law distribution. The "normlog" is simply the normal distribution where all
values are positive. Note, this is not log-normal. It is the normal with a log link.
Similarly to the inverse gaussian distribution where the mean is an exponentiated.
This comes from the GLM theory. The "epois" stands for the exponential-Poisson, the "gep" for the
generalized exponential-Poisson and the "pe" for the Poisson-exponential distribution.
The "wp" stands for the Weibull Poisson, the "be" for the beta exponential, the "frechet2" for the
two-parameter Frechet, for the  the "zigamma" and "ziweibull" stand for the zero inflated gamma and
Weibull distributions, respectively, and they accept zeros. The "halft1" is the half t distribution with
unity scatter parameter, the "halft" for the half t distribution, and "foldedt" for the folded t distribution.
}
\item{tol}{
The tolerance level up to which the maximisation stops; set to 1e-07 by default.
}
\item{maxiters}{
The maximum number of iterations the Newton-Raphson will perform.
}
}

\details{
Instead of maximising the log-likelihood via a numerical optimiser we have used a Newton-Raphson algorithm which is faster. See wikipedia for the equations to be solved.
For the t distribution we need the degrees of freedom and estimate the location and scatter parameters.

}

\value{
Usually a list with three elements, but this is not for all cases.
\item{iters}{
The number of iterations required for the Newton-Raphson to converge.}
\item{loglik}{
The value of the maximised log-likelihood.
}
\item{param}{
The vector of the parameters.
}
}

\references{
Kalimuthu Krishnamoorthy, Meesook Lee and Wang Xiao (2015). Likelihood ratio tests for comparing several gamma distributions. Environmetrics, 26(8):571--583.

N.L. Johnson, S. Kotz and N. Balakrishnan (1994). Continuous Univariate Distributions, Volume 1 (2nd Edition).

N.L. Johnson, S. Kotz a nd N. Balakrishnan (1970). Distributions in statistics: continuous univariate distributions, Volume 2.

Tsagris M., Beneki C. and Hassani H. (2014). On the folded normal distribution. Mathematics, 2(1):12--28.

Sharma V. K., Singh S. K., Singh U. and Agiwal V. (2015). The inverse Lindley distribution:
a stress-strength reliability model with application to head and neck cancer data. Journal of
Industrial and Production Engineering, 32(3): 162--173.

Barreto-Souza W. and Cribari-Neto F. (2009). A generalization of the exponential-Poisson distribution.
Statistics and Probability Letters, 79(24): 2493--2500.

Louzada F., Ramos P. L. and Ferreira H. P. (2020). Exponential-Poisson distribution: estimation and applications to rainfall and aircraft data with zero occurrence.
Communications in Statistics--Simulation and Computation, 49(4): 1024--1043.

Rodrigues G. C., Louzada F. and Ramos P. L. (2018). Poisson-exponential distribution: different methods of estimation. Journal of Applied Statistics, 45(1): 128--144.

Taylor S. and Pollard K. (2009). Hypothesis Tests for Point-Mass Mixture Data with Application to Omics Data with Many Zero Values. Statistical Applications in Genetics and Molecular Biology, 8(1): 1--43.

Percontini A., Blas B. and Cordeiro G. M. (2013). The beta Weibull Poisson distribution. Chilean Journal of Statistics, 4(2): 3--26.

Mahmoudi E., Zamani H. and Meshkat R. (2018). Poisson-beta exponential distribution: properties and applications. Journal of Statistical Research of Iran, 15(1): 119--146.

Suraphee S., Phoophiwfa T., Rattanametawee W., Seenoi P., Volodin A. & Busababodhin P. (2023). Probability Models and Some Mathematical Techniques on Parameter Estimation for Daily Rainfall Extremes: Application to Daily Rainfall in Southern Thailand. Lobachevskii Journal of Mathematics, 44(11), 4881--4892.

Psarakis and Panaretos (1990). The folded t distribution. Communications in Statistics--Theory and Methods, 19(7): 2717--2734.

You can also check the relevant wikipedia pages for these distributions.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{disc.mle}, \link{real.mle}, \link{prop.mle}
}
}

\examples{
x <- rgamma(100, 3, 4)
positive.mle(x, distr = "gamma")
}

\name{Column-wise MLE of some censored models}
\alias{colcens.mle}
\title{
Column-wise MLE of some censored models
}

\description{
Column-wise MLE of some censored models.
}

\usage{
colcens.mle(x, distr = "censweibull", di, tol = 1e-07, parallel = FALSE, cores = 0)
}

\arguments{
\item{x}{
A vector with positive valued data and zero values. If there are no zero values, a simple normal model is fitted in the end.
}
\item{distr}{
The distribution to fit. "censweibull" for the censored Weibull, "censpois" for the left censored Poisson and "tobit for the Tobit model. For the "censpois" the lowest value in x is taken as the censored point and values below that number are considered to be censored.
}
\item{di}{
A vector of 0s (censored) and 1s (not censored) values.
}
\item{tol}{
The tolerance level up to which the maximisation stops; set to 1e-07 by default.
}
\item{parallel}{
Do you want to calculations to take place in parallel? The default value is FALSE.
}
\item{cores}{
In case you set parallel = TRUE, then you need to specify the number of cores.
}
}

\details{
For each column, the same distribution is fitted and its parameters and log-likelihood are computed.
}

\value{
A matrix with two, three or four columns. The first one or the first two contain the parameter(s) of the
distribution and the second or third column the relevant log-likelihood.
}

\references{
Tobin James (1958). Estimation of relationships for limited dependent variables. Econometrica. 26(1): 24--36.

https://en.wikipedia.org/wiki/Tobit_model

Fritz Scholz (1996). Maximum Likelihood Estimation for Type I Censored Weibull Data Including Covariates.
Technical report. ISSTECH-96-022, Boeing Information & Support Services, P.O. Box 24346, MS-7L-22.

}

\author{
Michail Tsagris, Sofia Piperaki and Nikolaos Kontemeniotis.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com} and Nikolaos Kontemeniotis \email{kontemeniotisn@gmail.com}.
}

\seealso{
\code{ \link{cens.mle}, \link{colpositive.mle}, \link{colreal.mle}
}
}

\examples{
x1 <- matrix( rpois(1000 * 10, 15), ncol = 10)
x <- x1
x[x <= 10] <- 10
colMeans(x) ## simple Poisson
colcens.mle(x, distr = "censpois")
}

\name{MLE of some continuous multivariate distributions}
\alias{mv.mle}
\title{
MLE of some continuous multivariate distributions
}

\description{
MLE of some continuous multivariate distributions.
}

\usage{
mv.mle(x, distr = "mvnorm", v = 1, tol = 1e-7)
}

\arguments{
\item{x}{
A matrix with numerical data.
}
\item{distr}{
The distribution to fit. "mvnorm" stands for the multivariate normal distribution,
"mvlnorm" for the multivariate log-normal, "mvt" is the multivariate t distribution and
"invdir" stands for the inverse Dirichlet distribution. If you want the multivariate Cauchy distribution, simply choose "mvt" and set the v argument equal to 1.
}
\item{v}{
The degrees of freedom. Must be a positive number, greater than zero.
}
\item{tol}{
The tolerance value to terminate the EM algorithm.
}
}

\details{
The mean vector, covariance matrix and the value of the log-likelihood of the
multivariate normal or log-normal distribution is calculated.
For the log-normal distribution we also provide the expected value and the covariance matrix.
The location vector, scatter matrix and the value of the log-likelihood for the multivariate t distribution is calculated.
Maximum likelihood estimation of the parameters of the inverted is performed via Newton-Raphson.
}

\value{
A list including:
\item{loglik}{
The log-likelihood multivariate distribution.
}
\item{mu}{
The mean vector.
}
\item{sigma}{
The covariance matrix.
}
\item{m}{
The expected mean vector of the multivariate log-normal distribution.
}
\item{s}{
The expected covariance matrix of the multivariate log-normal distribution.
}
}

\references{
Kotz S., Balakrishnan N. and Johnson N. L. (2004). Continuous multivariate distributions, Volume 1: Models and applications (Vol. 1).
John wiley & sons.

Nadarajah S. and Kotz S. (2008). Estimation methods for the multivariate t distribution.
Acta Applicandae Mathematicae, 102(1): 99--118.

Bdiri T. and Bouguila N. (2012). Positive vectors clustering using inverted Dirichlet finite mixture models.
Expert Systems with Applications, 39(2): 1869--1882.

http://isi.cbs.nl/iamamember/CD2/pdf/329.PDF

https://en.wikipedia.org/wiki/Log-normal_distribution#Multivariate_log-normal
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{real.mle}
}
}

\examples{
x <- matrix( rnorm(100 * 5), ncol = 5)
res <- mv.mle(x)
}

\name{MLE of the ordinal model without covariates}
\alias{ordinal.mle}
\title{
MLE of the ordinal model without covariates
}

\description{
MLE of the ordinal model without covariates.
}

\usage{
ordinal.mle(y, link = "logit")
}

\arguments{
\item{y}{
A numerical vector with values 1, 2, 3,..., not zeros, or an ordered factor.
}
\item{link}{
This can either be "logit" or "probit". It is the link function to be used.
}
}

\details{
Maximum likelihood of the ordinal model (proportional odds) is implemented. See for example the "polr" command
in R or the examples.
}

\value{
A list including:
\item{loglik}{
The log-likelihood of the model.
}
\item{a}{
The intercepts (threshold coefficients) of the model.
}
}

\references{
Agresti, A. (2002) Categorical Data. Second edition. Wiley.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

%\note{
  %%  ~~further notes~~
    %}

\seealso{
\code{\link{colordinal.mle}
}
}

\examples{
y <- factor( rbinom(100,3,0.5), ordered = TRUE )
res <- ordinal.mle(y)
res <- ordinal.mle(y, link = "probit")
}

\name{MLE for multivariate discrete data}
\alias{mvdisc.mle}
\title{
MLE for multivariate discrete data
}

\description{
MLE for multivariate discrete data.
}

\usage{
mvdisc.mle(x, distr = "multinom", tol = 1e-07)
}

\arguments{
\item{x}{
A matrix with discrete valued non negative data.
}
\item{distr}{
The distribution to fit. "multinom" stands for the multinomial distribution, "dirimultinom" stands for the Dirichlet-multinomial distribution. "bp.mle" and "bp.mle2" stand for the bivariate Poisson distribution. The The "bp.mle" returns a lot of information and is slower than "bp.mle2", which returns fewer information, but is faster.
}
\item{tol}{
The tolerance level to terminate the Newton-Raphson algorithm for the Dirichlet multinomial distribution.
}
}

\value{
A list including:
\item{iters}{
The number of iterations required by the Newton-Raphson algortihm.
}
\item{loglik}{
A vector with the value of the maximised log-likelihood.
}
\item{param}{
A vector of the parameters.
}
\item{prob}{
A vector with the estimated probabilities.
}

For the "bp.mle" a list including:
\item{lambda}{
A vector with the estimated values of \eqn{(\lambda_1}, \eqn{\lambda_2)} and \eqn{\lambda_3}.
Note that \eqn{\hat{\lambda}_1=\bar{x}_1 - \lambda_3} and \eqn{\hat{\lambda}_1=\bar{x}_1 - \lambda_3}, where
\eqn{\bar{x}_1} and \eqn{\bar{x}_2} are the two sample means.
}
\item{rho}{
The estimated correlation coefficient, that is: \eqn{\dfrac{\hat{\lambda}_3}{\sqrt{\left(\hat{\lambda}_1 + \hat{\lambda_3}\right)\left(\hat{\lambda}_2 + \hat{\lambda_3}\right)}}}.
}
\item{ci}{
The 95\% Confidence intervals using the observed and the asymptotic information matrix.
}
\item{loglik}{
The log-likelihood values assuming independence (\eqn{\lambda_3=0}) and assuming the bivariate Poisson distribution.
}
\item{pvalue}{
Three p-values for testing \eqn{\lambda_3=0}. These are based on the log-likelihood ratio and two Wald tests using the observed and the asymptotic information matrix.
}

For the "bp.mle2" a list including:
\item{lambda}{
A vector with the estimated values of \eqn{(\lambda_1}, \eqn{\lambda_2)} and \eqn{\lambda_3}.
Note that \eqn{\hat{\lambda}_1=\bar{x}_1 - \lambda_3} and \eqn{\hat{\lambda}_1=\bar{x}_1 - \lambda_3}, where
\eqn{\bar{x}_1} and \eqn{\bar{x}_2} are the two sample means.
}
\item{loglik}{
The log-likelihood values assuming independence (\eqn{\lambda_3=0}) and assuming the bivariate Poisson distribution.
}

}

\references{
Johnson Norman L., Kotz Samuel and Balakrishnan (1997). Discrete Multivariate Distributions. Wiley.

Kawamura K. (1984). Direct calculation of maximum likelihood estimator for the bivariate
Poisson distribution. Kodai Mathematical Journal, 7(2): 211--221.

Kocherlakota S. and Kocherlakota K. (1992). Bivariate discrete distributions. CRC Press.

Karlis D. and Ntzoufras I. (2003). Analysis of sports data by using bivariate poisson models.
Journal of the Royal Statistical Society: Series D (The Statistician), 52(3): 381--393.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

\seealso{
\code{ \link{disc.mle}, \link{coldisc.mle}
}
}

\examples{
x <- t( rmultinom(1000, 20, c(0.4, 0.5, 0.1) ) )
mvdisc.mle(x, distr = "multinom")
}

\name{Column-wise MLE of some circular distributions}
\alias{colcirc.mle}
\title{
Column-wise MLE of some circular distributions
}

\description{
Column-wise MLE of some circular distributions.
}

\usage{
colcirc.mle(x, distr = "vm", N = 2, ina, tol = 1e-07, maxiters = 100, parallel = FALSE)
}

\arguments{
\item{x}{
A numerical matrix with the circular data. They must be expressed in radians.
}
\item{distr}{
The type of distribution to fit, "vm" stands for the von Mises, "spml" is the angular Gaussian, "purka" is the Purkayastha, and "wrapcauchy" is the wrapped Cauchy distribution, "circexp" and "circbeta" stand for the circular exponential and the circular beta distributions, respectively. "cardio" is the cardioid distribution and "ggvm" is the generalized von Mises distribution, "cipc" is the circular independent projected Cauchy, "gcpc" is the generalised circular projected Cauchy distribution and "mmvm" is the multi-modal von Mises distribution. "multivm" and "multispml" denote the von Mises and the angular Gaussian but for multiple samples.
}
\item{N}{
The number of modes to consider in the multi-modal von Mises distribution.
}
\item{ina}{
A numerical vector with discrete numbers starting from 1, i.e. 1, 2, 3, 4,... or a factor variable. Each number denotes a sample or group. If you supply a continuous valued vector the function will obviously provide wrong results. This is only for "multivm" and "multispml".
}
\item{tol}{
The tolerance level to stop the iterative process of finding the MLEs.
}
\item{maxiters}{
The maximum number of iterations to implement. This is for the "spml" only.
}
\item{parallel}{
Should the computations take place in parallel? This is for the "spml" only.
}
}

\details{
The parameters of the von Mises, the bivariate angular Gaussian and wrapped Cauchy distributions are estimated.
For the wrapped Cauchy, the iterative procedure described by Kent and Tyler (1988) is used.
As for the von Mises distribution, we use a Newton-Raphson to estimate the concentration parameter.
The angular Gaussian is described, in the regression setting in Presnell et al. (1998).
}

\value{
A matrix with two, columns. The first one contains the parameters of the distribution
and the second columns contains the log-likelihood values.
}

\references{
Mardia K. V. and Jupp P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Sra S. (2012). A short note on parameter approximation for von Mises-Fisher distributions:
and a fast implementation of \eqn{I_s(x)}. Computational Statistics, 27(1): 177--190.

Presnell Brett, Morrison Scott P. and Littell Ramon C. (1998). Projected multivariate linear models for directional data. Journal of the American Statistical Association, 93(443): 1068--1077.

Kent J. and Tyler D. (1988). Maximum likelihood estimation for the wrapped Cauchy distribution.
Journal of Applied Statistics, 15(2): 247--254.

Dietrich T. and Richter W. D. (2017). Classes of geometrically generalized von Mises distributions.
Sankhya B, 79(1): 21--59.

https://en.wikipedia.org/wiki/Wrapped_exponential_distribution

Jammalamadaka S. R. and Kozubowski T. J. (2003). A new family of circular models:
The wrapped Laplace distributions.
Advances and Applications in Statistics, 3(1), 77--103.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics (accepted for publication).
https://arxiv.org/pdf/2302.02468.pdf

Barnett M. J. and Kingston R. L. (2024). A note on the Hendrickson-Lattman phase probability
distribution and its equivalence to the generalized von Mises distribution.
Journal of Applied Crystallography, 57(2).

Purkayastha S. (1991). A Rotationally Symmetric Directional Distribution: Obtained through Max-
imum Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83.

Cabrera J. and Watson G. S. (1990). On a spherical median related distribution. Communications
in Statistics-Theory and Methods, 19(6): 1973--1986
}

\author{
Michail Tsagris, Sofia Piperaki and Rafail Vargiakakis.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}, Sofia Piperaki  \email{sofiapip23@gmail.com} and Rafail Vargiakakis \email{rafailvargiakakis@gmail.com}.
}

%\note{
%%  ~~further notes~~
%}
\seealso{
\code{\link{circ.mle},
}
}

\examples{
x <- matrix( rnorm(100 * 10, 3, 1), ncol = 10)
x <- x / sqrt( rowSums(x^2) )
res <- colcirc.mle(x, distr = "spml")
}

\name{MLE of Bell type (univariate continuous) distributions}
\alias{bell.mle}
\title{
MLE of Bell type (univariate continuous) distributions
}

\description{
MLE of Bell type (univariate continuous) distributions.
}

\usage{
bell.mle(x, a, b, k, lambda, distr = "BB12", method = "B")
}

\arguments{
\item{x}{
A vector with continuous valued data.
}
\item{a}{
Initial value for the strictly positive scale parameter of the baseline distribution.
}
\item{b}{
Initial value for the strictly positive shape parameter of the baseline distribution.
}
\item{k}{
Initial value for the strictly positive shape parameter of the baseline distribution.
}
\item{lambda}{
Initial value for the strictly positive parameter of the Bell distribution.
}
\item{distr}{
The distribution to fit, "BB12" stands for the Bell Burr-12, "BBX" for the Bell Burr-10,
"BE" for the Bell exponential, "BEW" for the Bell exponentiated Weibull, "BEE" for the Bell exponentiated exponential, "BF" for the Bell Fisk distribution, "BL" for the Bell Lomax, "BW" for the Bell Weibull distribution, "CBB12" for the  complementary Bell Burr-12, "CBBX" for the complementary Bell Burr-X distribution, "CBE" for the complementary Bell exponential distribution, "CBEW" for the complementary Bell exponentiated Weibul distribution, "CBEE" for the complementary Bell extended exponentia distribution, "CBF" for the complementary Bell Fisk distribution, "CBL" for the complementary Bell Lomax distribution, and "CBW" for the complementary Bell Weibull distribution.
}
\item{method}{
The procedure for optimising the log-likelihood function after setting the initial values of the parameters and data vector for which the Bell-based distributions are fitted. It could be "Nelder-Mead," "BFGS," "CG," "L-BFGS-B," or "SANN." "BFGS" is set as the default.
}
}

\details{
These functions facilitate the fitting of Bell-based extended distributions, including the Bell Burr-12(a, b, k, lambda), Bell Burr-10(a, lambda), Bell exponential(a, lambda), Bell exponentiated Weibull(a, b, k, lambda), Bell extended exponential(a, b, lambda), Bell Fisk(a, b, lambda), Bell Lomax(a, b, lambda), Bell Weibull(a, b, lambda), complementary  Bell Burr-12(a, b, k, lambda), complementary Bell Burr-10(a, lambda), complementary Bell exponential(a, lambda), complementary Bell exponentiated Weibull(a, b, k, lambda), complementary Bell extended exponential(a, b, lambda), complementary Bell Fisk(a, b, lambda), complementary Bell Lomax(a, b, lambda), and complementary Bell Weibull(a, b, lambda).
}

\value{
A list including:
\item{param}{
The parameters of the distribution.
}
\item{loglik}{
The log-likelihood value.
}
}

\references{
Fayomi A., Tahir M. H., Algarni A., Imran M. and Jamal F. (2022). A new useful exponential model with applications to quality control and actuarial data. Computational Intelligence and Neuroscience, 2022.

Alanzi, A. R., Imran M., Tahir M. H., Chesneau C., Jamal F. Shakoor S. and Sami, W. (2023).
Simulation analysis, properties and applications on a new Burr XII model based on the Bell-X functionalities. AIMS Mathematics, 8(3): 6970--7004.

Algarni A. (2022). Group Acceptance Sampling Plan Based on New Compounded Three-
Parameter Weibull Model. Axioms, 11(9): 438.

Kleiber, C. and Kotz, S. (2003). Statistical size distributions in economics and actuarial sciences. John Wiley & Sons.

Zimmer W. J., Keats J. B. and Wang F. K. (1998). The Burr XII distribution in reliability analysis.
Journal of Quality Technology, 30(4): 386--394.

Nadarajah S., Cordeiro G. M. and Ortega E. M. (2013). The exponentiated Weibull distribution: a survey. Statistical Papers, 54: 839--877.

Nadarajah S. (2011). The exponentiated exponential distribution: a survey. Advances in
Statistical Analysis, 95: 219--251.
}

\author{
Muhammad Imran.

R implementation and documentation: Muhammad Imran \email{imranshakoor84@yahoo.com}.
}

\seealso{
\code{ \link{disc.mle}
}
}

\examples{
x <- rgamma(1000, 3, 5)
# Fitting of the Bell Burr-12 (BB12) distribution
bell.mle(x, a = 2.1, b = 1.3, k = 0.02, lambda = 1.2, distr = "BB12", method = "B")
# Fitting of the Bell exponential (BE) distribution
bell.mle(x, a = 2.1, lambda = 0.5 ,distr = "BE", method = "B")
}

\name{Column-wise MLE of some discrete distributions}
\alias{coldisc.mle}

\title{
Column-wise MLE of some discrete distributions
}

\description{
Column-wise MLE of some discrete distributions.
}

\usage{
coldisc.mle(x, distr = "poisson", N = NULL, type = 1, tol = 1e-07)
}

\arguments{
\item{x}{
A numerical matrix with count data, dscrete data, integers. Each column refers to a different vector of observations of the same distribution.
}
\item{distr}{
The distribution to fit, "poisson" stands for the Poisson, "zip" for the zero-inflated Poisson,
"ztp" for the zero-truncated Poisson, "negbin" for the negative binomial, "binom" for the binomial,
"borel" for the Borel distribution, "geom" for the geometric, "logseries" for the log-series distribution,
"betageom" for the beta-geometric, "betabinom" for the beta-binomial distribution, "skellam" for the
Skellam distribution, "gp" for the generalised Poisson distribution, "gammapois" for the gamma-Poisson
distribution, "cc" for the Cacoullos-Cauchy distribution, "cc0" for the Cacoullos-Cauchy distribution
with zero location, "com-pois" for the Conway-Maxwell Poisson (COM-Poisson), and "zicom-pois" for the
zero inflated COM-Poisson distribution. "tppxg" and "tpxg" refer to the two-parameter Poisson Xgamma
and the two-parameter Xgamma distribution, respectively.
}
\item{N}{
This is for the binomial and the beta binomial distribution only, a vector specifying the total number of trials. If it is NULL in the binomial, it is estimated by the data.
}
\item{type}{
This is for the geometric distribution only. Type 1 refers to the case where the
minimum is zero and type 2 for the case of the minimum being 1.
}
\item{tol}{
The tolerance level up to which the maximisation stops set to 1e-07 by default.
}
}

\details{
For each column, the same distribution is fitted and its parameter and log-likelihood are computed.
}

\value{
A matrix with two, columns. The first one contains the parameters of the distribution
and the second columns contains the log-likelihood values.
}

\references{
Lambert D. (1992). Zero-Inflated Poisson Regression, with an Application to Defects in
Manufacturing. Technometrics. 34 (1): 1--14

Johnson N. L., Kotz S. and Kemp A. W. (1992). Univariate Discrete
Distributions (2nd ed.). Wiley.

Skellam J. G. (1946) The frequency distribution of the difference between two Poisson variates belonging to different populations.
Journal of the Royal Statistical Society, series A 109/3, 26.

Nikoloulopoulos A.K. and Karlis D. (2008). On modeling count data: a comparison of some well-known discrete distributions. Journal of Statistical Computation and Simulation, 78(3): 437--457.

Papadatos N. (2022). The characteristic function of the discrete Cauchy distribution In Memory of T. Cacoullos. Journal of Statistical Theory and Practice, 16(3): 47.}

\author{
Michail Tsagris, Sofia Piperaki and Nikolaos Kontemeniotis.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com} and Nikolaos Kontemeniotis \email{kontemeniotisn@gmail.com}.
}

\seealso{
\code{\link{disc.mle} }
}

\examples{
x <- matrix(rpois(1000 * 50, 10), ncol = 50)
a <- coldisc.mle(x, distr = "poisson")
}

\name{Column-wise MLE of continuous univariate distributions defined on the positive line}
\alias{colpositive.mle}
\title{
Column-wise MLE of continuous univariate distributions defined on the positive line}

\description{
Column-wise MLE of continuous univariate distributions defined on the positive line.
}

\usage{
colpositive.mle(x, distr = "gamma", tol = 1e-07, maxiters = 100, parallel = FALSE)
}

\arguments{
\item{x}{
A matrix with positive valued data (zeros are not allowed).
}
\item{distr}{
The distribution to fit. "gamma" stands for the gamma distribution, "chisq" for the \eqn{\chi^2} distribution,
"weibull" for the Weibull, "lomax" for the Lomax, "foldnorm" for the folded normal, "betaprime" for the
beta-prime distribution, "lognorm" for the log-normal, "logcauchy" for the log-Cauchy, "loglogictic" for
the log-logistic distribution. "halfnorm" for the half-normal, "invgauss" for the inverse Gaussian,
"pareto" for the Pareto distribution, "exp" for the exponential distribution, "exp2" I do not remember,
"maxboltz" for the Maxwell-Boltzman distribution, "rayleigh" is the Rayleigh distribution, "lindley"
is the Lindley distribution, "halfcauchy" is the half-Cauchy distribution and "powerlaw" is the power
law distribution. The "normlog" is simply the normal distribution where all values are positive.
Note, this is not log-normal. It is the normal with a log link. Similarly to the inverse gaussian
distribution where the mean is an exponentiated. This comes from the GLM theory. The "epois" stands
for the exponential-Poisson, the "gep" for the generalized exponential-Poisson and the "pe" for the
Poisson-exponential distribution. The "wp" stands for the Weibull Poisson, the "be" for the beta
exponential, the "frechet2" for the two-parameter Frechet, for the  the "zigamma" and "ziweibull"
stand for the zero inflated gamma and Weibull distributions, respectively, and they accept zeros.
The "halft1" is the half t distribution with unity scatter parameter, the "halft" for the half t
distribution, and "foldedt" for the folded t distribution.
}
\item{tol}{
The tolerance level up to which the maximisation stops; set to 1e-07 by default.
}
\item{maxiters}{
The maximum number of iterations the Newton-Raphson will perform for the Weibull distribution.
}
\item{parallel}{
Do you want to calculations to take place in parallel? The default value is FALSE. This is only for the Weibull distribution.
}
}

\details{
For each column, the same distribution is fitted and its parameter and log-likelihood are computed.
}

\value{
A matrix with two, three or five (for the colnormlog.mle) columns. The first one or the first two contain the parameter(s) of the distribution and the other columns contain the log-likelihood values.
}

\references{
Kalimuthu Krishnamoorthy, Meesook Lee and Wang Xiao (2015). Likelihood ratio tests for comparing several
gamma distributions. Environmetrics, 26(8): 571--583.

N.L. Johnson, S. Kotz and N. Balakrishnan (1994). Continuous Univariate Distributions, Volume 1 (2nd Edition).

N.L. Johnson, S. Kotz a nd N. Balakrishnan (1970). Distributions in statistics: continuous univariate
distributions, Volume 2.

Tsagris M., Beneki C. and Hassani H. (2014). On the folded normal distribution. Mathematics, 2(1): 12--28.

Sharma V. K., Singh S. K., Singh U. and Agiwal V. (2015). The inverse Lindley distribution:
a stress-strength reliability model with application to head and neck cancer data. Journal of
Industrial and Production Engineering, 32(3): 162--173.

Psarakis and Panaretos (1990). The folded t distribution. Communications in Statistics--Theory and Methods, 19(7): 2717--2734.

You can also check the relevant wikipedia pages for these distributions.
}

\author{
Michail Tsagris, Sofia Piperaki and Rafail Vargiakakis.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr}, Sofia Piperaki  \email{sofiapip23@gmail.com} and Rafail Vargiakakis \email{rafailvargiakakis@gmail.com}.
}

\seealso{
\code{ \link{disc.mle}, \link{real.mle}, \link{prop.mle}
}
}

\examples{
x <- matrix( rgamma(500, 3, 4), ncol = 5 )
colpositive.mle(x, distr = "gamma")
}

\name{MLE of (hyper-)spherical distributions}
\alias{hspher.mle}
\title{
MLE of (hyper-)spherical distributions
}

\description{
MLE of (hyper-)spherical distributions.
}

\usage{
hspher.mle(x, distr = "vmf", ina, full = FALSE, ell = FALSE, tol = 1e-07)
}

\arguments{
\item{x}{
A matrix with directional data, i.e. unit vectors.
}
\item{distr}{
The distribution to fit. Spherical distributions: "purka" is the Purkayastha distribution,
and "sipc" is the spherical isotropic projected Cauchy. These are rotationally symmetric
distributions. The "wood" is the Wood distribution, a bimodal distribution. The next three
are elliptically symmetric distributions. The "kent" is the Kent distribution, "esag" is
the elliptically symmetric angular Gaussian and the "sespc" is the spherical elliptically
symmetric projected Cauchy distribution. The "svmf" is the scaled von Mises-Fisher distribution,
a rotationally symmetric distribution developed for spherical and hyper-spherical data.

Spherical and hyper-spherical distributions: "vmf" stands for the von Mises-Fisher
distribution, "multivmf" is for the vMF with multiple groups, "acg" is the angular
central Gaussian and  and the "pkbd" is the Poisson kernel based distribution.
The "spcauchy" and "spcauchy2" are the spherical Cauchy (2 different methods of estimation),
"pkbd" and "pkbd2" is the Poisson-kernel based distribution, "iag" stands for the
independent angular Gaussian distribution, and works for spherical and hyper-spherical data,
and "ESAGd" is a generalization ofESAG to the hyper-sphere.
}
\item{ina}{
A numerical vector with discrete numbers starting from 1, i.e. 1, 2, 3, 4,... or a
factor variable. Each number denotes a sample or group. If you supply a continuous
valued vector the function will obviously provide wrong results.
}
\item{full}{
If you want some extra information, the inverse of the covariance matrix,
set this equal to TRUE. Otherwise leave it FALSE.
}
\item{ell}{
This is for the multivmf.mle only. Do you want the log-likelihood returned?
The default value is TRUE.
}
\item{tol}{
The tolerance value at which to terminate the iterations.
}
}

\details{
For the von Mises-Fisher, the normalised mean is the mean direction. For the concentration
parameter, a Newton-Raphson is implemented. For the angular central Gaussian distribution
there is a constraint on the estimated covariance matrix; its trace is equal to the
number of variables. An iterative algorithm takes place and convergence is guaranteed.
Newton-Raphson for the projected normal distribution, on the sphere, is implemented as well.

The "vmf" estimates the mean direction and concentration of a fitted von Mises-Fisher
distribution. The von Mises-Fisher distribution for groups of data is also implemented.
The "acg"" fits the angular central Gaussian distribution. There is a constraint on the
estimated covariance matrix; its trace is equal to the number of variables. An iterative
algorithm takes place and convergence is guaranteed. The "iag" implements MLE of the
(hyper-)spherical projected normal distribution. The "esag" is for spherical data, while
"ESAGd" is for hyper-spherical data. The "spcauchy" is faster than the "spcacuhy2"
because it employs the Newton-Raphson algortihm, but for high dimensions the latter
is preferred. Both functions estimate the parameters of the spherical Cauchy distribution,
for any dimension. Despite the name sounds confusing, it is implemented for arbitrary
dimensions, not only the sphere. The function employs a combination of the fixed points
iteration algorithm and the Brent algorithm. The "pkbd" is faster than "pkbd2" beacuse
it employs the Newton-Raphson algorithm, but for high dimensions the latter is preferred.
Both estimate the parameters of the Poisson kernel based distribution (PKBD), for any
dimension. The "sipc" implements MLE of the spherical independent projected Cauchy
distribution, for spherical data only.
}

\value{
For the von Mises-Fisher a list including:
\item{loglik}{
The maximum log-likelihood value.
}
\item{mu}{
The mean direction.
}
\item{kappa}{
The concentration parameter.
}
For the multi von Mises-Fisher a list including:
\item{loglik}{
A vector with the maximum log-likelihood values if ell is set to TRUE. Otherwise NULL is returned.
}
\item{mi}{
A matrix with the group mean directions.
}
\item{ki}{
A vector with the group concentration parameters.
}

For the angular central Gaussian a list including:
\item{iter}{
The number if iterations required by the algorithm to converge to the solution.
}
\item{cova}{
The estimated covariance matrix.
}
For the spherical projected normal a list including:
\item{iters}{
The number of iteration required by the Newton-Raphson.
}
\item{mesi}{
A matrix with two rows. The first row is the mean direction and the second is the mean vector.
The first comes from the second by normalising to have unit length.
}
\item{param}{
A vector with the elements, the norm of mean vector, the log-likelihood and the log-likelihood of the spherical uniform distribution.
The third value helps in case you want to do a log-likleihood ratio test for uniformity.
}

For the spherical Cauchy and the PKBD a list including:
\item{mesos}{
The mean in \eqn{R^{d+1}}. See Tsagris and Alenazy (2023) for a re-parametrization that
applies in the spherical Cauchy also.
}
\item{mu}{
The mean direction.
}
\item{gamma}{
The norm of the mean in \eqn{R^{d+1}}. See Tsagris and Alenazy (2023) for a re-parametrization that
applies in the spherical Cauchy also.
}
\item{rho}{
The concetration parameter, this takes values in [0, 1).
}
\item{loglik}{
The log-likelihood value.
}
For the SIPC a list including:
\item{mu}{
The mean direction.
}
\item{loglik}{
The log-likelihood value.
}

For the Kent a list including:
\item{runtime}{
The run time of the procedure.
}
\item{G}{
A 3 x 3 matrix whose first column is the mean direction. The second and third columns are the major and minor axes respectively.
}
\item{param}{
A vector with the concentration \eqn{\kappa} and ovalness \eqn{\beta} parameters and the angle \eqn{\psi} used to rotate \bold{H}
and hence estimate \bold{G} as in Kent (1982).
}
\item{logcon}{
The logarithm of the normalising constant, using the third type approximation (Kume and Wood, 2005).
}
\item{loglik}{
The value of the log-likelihood.
}
For the ESAG a list including:
\item{mu}{
The mean vector in \eqn{R^3}.
}
\item{gam}{
The two \eqn{\gamma} parameters.
}
\item{loglik}{
The log-likelihood value.
}
\item{vinv}{
The inverse of the covariance matrix. It is returned if the argument "full" is TRUE.
}
\item{rho}{
The \eqn{rho} parameter (smallest eigenvalue of the covariance matrix). It is returned if the argument "full" is TRUE.
}
\item{psi}{
The angle of rotation \eqn{\psi} set this equal to TRUE. It is returned if the argument "full" is TRUE.
}
\item{iag.loglik}{
The log-likelihood value of the isotropic angular Gaussian distribution. That is, the projected
normal distribution which is rotationally symmetric.
}

For the SESPC a list including:
\item{mu}{
The mean vector in \eqn{R^3}.
}
\item{theta}{
The two \eqn{\theta} parameters.
}
\item{loglik}{
The log-likelihood value.
}
\item{vinv}{
The inverse of the covariance matrix. It is returned if the argument "full" is TRUE.
}
\item{lambda}{
The \eqn{\lambda_2} parameter (smallest eigenvalue of the covariance matrix). It is returned if the argument "full" is TRUE.
}
\item{psi}{
The angle of rotation \eqn{\psi} set this equal to TRUE. It is returned if the argument "full" is TRUE.
}
\item{sipc.loglik}{
The log-likelihood value of the isotropic prohected Cuchy distribution, which is rotationally symmetric.
}

For the Wood distribution a list including:
\item{info}{
A 5 x 3 matrix containing the 5 parameters, \eqn{\gamma}, \eqn{\delta}, \eqn{\alpha}, \eqn{\beta} and \eqn{\kappa} along with their corresponding 95\% confidence intervals all expressed in degrees.
}
\item{modes}{
The two axis of the modes of the distribution expressed in degrees.
}
\item{unitvectors}{
A 3 x 3 matrix with the 3 unit vectors associated with the \eqn{\gamma} and \eqn{\delta} parameters.
}
\item{loglik}{
The value of the log-likelihood.
}

For the Purkayastha a list including:
\item{theta}{
The median direction.
}
\item{alpha}{
The concentration parameter.
}
\item{loglik}{
The log-likelihood.
}
\item{alpha.sd}{
The standard error of the concentration parameter.
}

For the scaled von Mises-Fisher distribution a list including:
\item{mu}{
The estimated mean direction.
}
\item{kappa}{
The estimated concentration parameter.
}
\item{a}{
The estimated vector of alphas, the first value is 1, by default.
}
\item{loglik}{
the log-likelihood value.
}
\item{Gamma}{
The estimated matrix with the \eqn{\gamma} vectors. The first column of this matrix is the mean direction.
}
}

\references{
Mardia, K. V. and Jupp, P. E. (2000). Directional statistics. Chicester: John Wiley & Sons.

Sra, S. (2012). A short note on parameter approximation for von Mises-Fisher distributions: and a fast implementation of Is(x).
Computational Statistics, 27(1): 177--190.

Tyler D. E. (1987). Statistical analysis for the angular central Gaussian distribution on the sphere.
Biometrika 74(3): 579-589.

Zehao Yu and Xianzheng Huang (2024). A new parameterization for elliptically symmetric angular Gaussian distributions of arbitrary dimension. Electronic Journal of Statististics, 18(1): 301--334.

Tsagris M. (2024). Directional data analysis: spherical Cauchy or the Poisson-kernel based distribution?.
Statistics and Computing (accepted for publication).
https://arxiv.org/pdf/2409.03292

Paine P.J., Preston S.P., Tsagris M. and Wood A.T.A. (2018). An Elliptically Symmetric Angular Gaussian Distribution. Statistics and Computing, 28, 689--697.

Tsagris M. and Alzeley O. (2025). Circular and spherical projected Cauchy distributions:
A Novel Framework for Circular and Directional Data Modelling.
Australian & New Zealand Journal of Statistics (accepted for publication).
https://arxiv.org/pdf/2302.02468.pdf

Kato S. and McCullagh P. (2020). Some properties of a Cauchy family on the sphere derived from the
Mobius transformations. Bernoulli, 26(4): 3224--3248.
https://arxiv.org/pdf/1510.07679.pdf

Golzy M. and Markatou M. (2020). Poisson kernel-based clustering on the sphere:
convergence properties, identifiability, and a method of sampling.
Journal of Computational and Graphical Statistics, 29(4): 758--770.

Sablica L., Hornik K. and Leydold J. (2023). Efficient sampling from the PKBD distribution.
Electronic Journal of Statistics, 17(2): 2180--2209.

Wood A.T.A. (1982). A bimodal distribution on the sphere.
Journal of the Royal Statistical Society, Series C, 31(1): 52--58.

Purkayastha S. (1991).  A Rotationally Symmetric Directional Distribution: Obtained through Maximum
Likelihood Characterization. The Indian Journal of Statistics, Series A, 53(1): 70--83

Cabrera J. and Watson G. S. (1990). On a spherical median related distribution.
Communications in Statistics-Theory and Methods, 19(6): 1973--1986.

Scealy J.L. and Wood A.T.A. (2019). Scaled von Mises-Fisher distributions and regression models for paleomagnetic directional data.
Journal of the American Statistical Association, 114(528):  1547--1560.
}

\author{
Michail Tsagris and Sofia Piperaki.

R implementation and documentation: Michail Tsagris \email{mtsagris@uoc.gr} and Sofia Piperaki  \email{sofiapip23@gmail.com}.
}

%\note{
%%  ~~further notes~~
%}

\seealso{
\code{ \link{circ.mle}
}
}

\examples{
m <- c(0, 0, 0, 0)
s <- cov(iris[, 1:4])
x <- matrix( rnorm(100 * 3), ncol = 3 )
x <- x / sqrt( rowSums(x^2) )
hspher.mle(x, distr = "iag")
}
